import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0
import "/usr/lib/qt4/imports/com/nokia/meego/UIConstants.js" as UIConstants
import Web2SMS 1.0

Plugin {
    id: container

    // Translation strings
    //% "Example plugin"
    pluginName: qsTrId("qtn_example_name")
    //% "A very simple plugin"
    pluginDescription: qsTrId("qtn_example_desc")

    // Required! Function to check if all required settings are set
    function isFinished() {
        // Check if the username is entered
        if ( username.text.length == 0 ) {
            showBanner(qsTrId("qtn_web2sms_genericaccountsettings_banner_enter_username"));
            return false;
        }

        // Update the display name
        account.displayName = username.text + " | " + pluginName;

        var credentials = {
            "use_push":"maybe",
            "be_evil":"yes",
            "FAIL":"false"
        };

        account.pluginCredentials = credentials;

        return true;
    }

    Label {
        text: qsTr("Username")
        color: UIConstants.COLOR_INVERTED_SECONDARY_FOREGROUND
    }

    TextField {
        id: username
        width: container.width
        text: account.username

        Binding {
            target: account
            property: "username"
            value: username.text
        }
    }

    Label {
        text: qsTr("Password")
        color: UIConstants.COLOR_INVERTED_SECONDARY_FOREGROUND
    }

    TextField {
        id: password
        width: container.width
        echoMode: TextInput.Password
        text: account.password

        Binding {
            target: account
            property: "password"
            value: password.text
        }
    }

    Label {
        text: qsTr("I am a custom configuration page!")
        font.pixelSize: 50
        wrapMode: Text.Wrap
        width: parent.width
    }
}
