import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0
import "/usr/lib/qt4/imports/com/nokia/meego/UIConstants.js" as UIConstants
import Web2SMS 1.0

Plugin {
    id: container

    // Translation strings
    pluginName: qsTrId("qtn_vodafone_ireland_name")
    pluginDescription: qsTrId("qtn_vodafone_ireland_desc")

    // Required! Function to check if all required settings are set
    function isFinished() {
        // Check if the username is entered
        if ( username.text.length == 0 ) {
            showBanner(qsTrId("qtn_web2sms_genericaccountsettings_banner_enter_username"));
            return false;
        }

        // Check if the password is entered
        if ( password.text.length == 0 ) {
            showBanner(qsTrId("qtn_web2sms_genericaccountsettings_banner_enter_password"));
            return false;
        }

        // Update the display name
        account.displayName = username.text + " | " + pluginName;

        // Define some dummy values
        var credentials = {
            "DATE":false,
            "TIME":false
        };

        account.pluginCredentials = credentials;

        return true;
    }

    Label {
        text: qsTrId("qtn_web2sms_genericaccountsettings_label_username")
        color: UIConstants.COLOR_INVERTED_SECONDARY_FOREGROUND
    }

    TextField {
        id: username
        width: container.width
        text: account.username

        Binding {
            target: account
            property: "username"
            value: username.text
        }
    }

    Label {
        text: qsTrId("qtn_web2sms_genericaccountsettings_label_password")
        color: UIConstants.COLOR_INVERTED_SECONDARY_FOREGROUND
    }

    TextField {
        id: password
        width: container.width
        echoMode: TextInput.Password
        text: account.password

        Binding {
            target: account
            property: "password"
            value: password.text
        }
    }
}
