#ifndef BACKENDSERVICE_H
#define BACKENDSERVICE_H

#include <QObject>
#include <QVariantMap>
#include <QStringList>

class BackendServicePrivate;

class BackendService : public QObject
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "net.muhkuh.web2smsbackend")

public:
    explicit BackendService(QObject *parent = 0);
    ~BackendService();

    /// Reload the plugins
    Q_INVOKABLE void reloadPlugins();
    Q_INVOKABLE bool reloadPlugin(const QString& absolutePath);

    /// List all loaded providers
    Q_INVOKABLE QStringList providers() const;

    /// Stop the service
    Q_INVOKABLE void stop();

    /// Send a message and return JSON data
    Q_INVOKABLE QString sendMessage(const QString& providerId,
                                    const QString& login,
                                    const QString& password,
                                    const QVariantList& numbers,
                                    const QString& smsText);

protected:
    friend class BackendServicePrivate;
    BackendServicePrivate* d;
};

#endif // BACKENDSERVICE_H
