// Local includes
#include "backendservice.h"

// Global includes
#include <QCoreApplication>
#include <QDBusConnection>

int main(int argc, char* argv[])
{
    QCoreApplication app(argc, argv);

    // Get the session bus
    QDBusConnection session = QDBusConnection::sessionBus();

    // Register the service
    if ( session.registerService("net.muhkuh.web2smsbackend") == false )
        return 1;

    // Create the backend service
    BackendService backendService;
    session.registerObject("/", &backendService);

    // Reload all plugins
    backendService.reloadPlugins();

    return app.exec();
}
