#ifndef PYTHONPROVIDERINTERFACE_H
#define PYTHONPROVIDERINTERFACE_H

// Util includes
#include <providerinterface.hpp>

// Global includes
#include <Python.h>

struct PythonProviderInterfacePrivate;

class PythonProviderInterface : public ProviderInterface
{
    Q_OBJECT
    Q_INTERFACES(ProviderInterface)

public:
    explicit PythonProviderInterface(QObject *parent = 0);
    ~PythonProviderInterface();

    // Initializer function
    bool initializeFromScript(PyObject* script);

    // Get the error string
    QString errorString() const;

    // ProviderInterface overrides
    bool sendMessage(const QString &login, const QString &password, const ContactInfoList &numbers, const QString &smsText, const QVariantMap &pluginDict);

protected:
    PythonProviderInterfacePrivate* d;
};

#endif // PYTHONPROVIDERINTERFACE_H
