#ifndef PYTHONPROVIDERPLUGIN_H
#define PYTHONPROVIDERPLUGIN_H

// Util includes
#include <providerplugin.hpp>

// Global includes
#include <QSet>

struct PythonProviderPluginPrivate;

class PythonProviderPlugin : public QObject
                           , public ProviderPlugin
{
    Q_OBJECT
    Q_INTERFACES(ProviderPlugin)

public:
    explicit PythonProviderPlugin(QObject *parent = 0);
    ~PythonProviderPlugin();

    // Loading and unloading of the script
    bool loadScript(const QString& absolutePath);
    void unloadScript();

    /// Get the error string from loading
    QString errorString() const;

    // ProviderPlugin overrides
    ProviderInterface* createProvider(const QByteArray& providerId) const;

protected:
    PythonProviderPluginPrivate* d;
};

#endif // PYTHONPROVIDERPLUGIN_H
