#ifndef PLUGINXMLFILE_H
#define PLUGINXMLFILE_H

#include <QSharedDataPointer>

class PluginXmlFileData;

class PluginXmlFile
{
public:
    PluginXmlFile();
    PluginXmlFile(const QString& absolutePath);
    PluginXmlFile(const PluginXmlFile &);
    PluginXmlFile &operator=(const PluginXmlFile &);
    ~PluginXmlFile();

    /// Load the data structure from xml
    bool loadFromFile(const QString& absolutePath);

    /// Get the error string from loading
    QString errorString() const;

    // Data
    QString providerId() const;
    QString pluginPath() const;

private:
    QSharedDataPointer<PluginXmlFileData> data;
};

#endif // PLUGINXMLFILE_H
