/*
 *
 *  Copyright (c) 2010 Christoph Keller <gri@nospam@not-censored.com>
 *
 *  This file is part of Web2SMS.
 *
 *  Web2SMS is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Web2SMS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Web2SMS. If not, see <http://www.gnu.org/licenses/>
 *
 */

#ifndef __web2sms_providerinterface_hpp__
#define __web2sms_providerinterface_hpp__

// Local includes
#include <contactinfo.hpp>
#include <message.hpp> // TODO: Remove

// Global includes
#include <QtCore/QtPlugin>
#include <QVariantMap>

// Forward declarations
class ProviderInterface;

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

class ProviderInterface : public QObject
{
  Q_OBJECT

public:
  ProviderInterface(QObject* parent = 0);
  ~ProviderInterface();

  /// Return the last error string
  //virtual QString errorString() const = 0;

  /// The send message function
  virtual bool sendMessage(const QString &login,
                           const QString &password,
                           const ContactInfoList &numbers,
                           const QString &smsText,
                           const QVariantMap& pluginDict) = 0;

signals:
  void sendMessageReply(bool success);
  void error(const QString& message);
};

Q_DECLARE_INTERFACE(ProviderInterface, "net.muhkuh.web2sms.ProviderInterface/1.0")

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

#endif // __web2sms_providerinterface_hpp__
