#ifndef CUSTOMWEBPAGE_H
#define CUSTOMWEBPAGE_H

#include <QHash>
#include <QWebPage>

class CustomWebPage : public QWebPage
{
    Q_OBJECT
public:
    explicit CustomWebPage(QWidget *parent = 0);

    /// Return the changed inputs
    QHash<QString, QStringList> changedInputs() const;

signals:
    void formSubmitted();

public slots:
    void onLoadFinished(bool ok);
    void onInputChanged(const QString& formName, const QString& inputName);

protected:
    bool acceptNavigationRequest(QWebFrame *frame, const QNetworkRequest &request, NavigationType type);

private:
    QHash<QString, QStringList> m_changedInputs;
};

#endif // CUSTOMWEBPAGE_H
