#include "loginbrowserpage.h"
#include "ui_loginbrowserpage.h"
#include "customwebpage.h"
#include "pluginwizard.h"

LoginBrowserPage::LoginBrowserPage(QWidget *parent) :
    QWizardPage(parent),
    ui(new Ui::LoginBrowserPage)
{
    ui->setupUi(this);

    // Setup a new custom page and add it to the web view
    CustomWebPage* page = new CustomWebPage(this);
    connect(page, SIGNAL(formSubmitted()), this, SLOT(onFormSubmitted()));
    ui->webView->setPage(page);

    setTitle( tr("Configure login data") );
    setSubTitle( tr("Please log in to proceed") );
}

LoginBrowserPage::~LoginBrowserPage()
{
    delete ui;
}

void LoginBrowserPage::initializePage()
{
    // Get the start address
    QString startAddress = field("startAddress").toString();

    // And update the view
    ui->webView->setUrl(startAddress);
}

void LoginBrowserPage::onFormSubmitted()
{
    // Get the changed inputs
    QHash<QString, QStringList> changedInputs = qobject_cast<CustomWebPage*>(ui->webView->page())->changedInputs();

    // Update the changed inputs on the wizard
    PluginWizard* pluginWizard = qobject_cast<PluginWizard*>(wizard());
    pluginWizard->setChangedInputs(changedInputs);

    // Go to the next page
    pluginWizard->next();
}
