#include "logindatapage.h"
#include "ui_logindatapage.h"
#include "pluginwizard.h"

#include <QLabel>

LoginDataPage::LoginDataPage(QWidget *parent) :
    QWizardPage(parent),
    ui(new Ui::LoginDataPage)
{
    ui->setupUi(this);
}

LoginDataPage::~LoginDataPage()
{
    delete ui;
}

void LoginDataPage::initializePage()
{
    // Delete all old controls
    qDeleteAll(ui->fieldLayout->children());

    // Get the wizard
    PluginWizard* pluginWizard = qobject_cast<PluginWizard*>(wizard());

    QHashIterator<QString, QStringList> iter(pluginWizard->changedInputs());
    while ( iter.hasNext() ) {
        iter.next();

        foreach(const QString& inputName, iter.value()) {
            QLabel* label = new QLabel(inputName, this);

            ui->fieldLayout->addWidget(label);
        }
    }
}
