#include "pluginwizard.h"

// Pages
#include "startpage.h"
#include "loginbrowserpage.h"
#include "logindatapage.h"

PluginWizard::PluginWizard(QWidget *parent)
: QWizard(parent)
{
    addPage(new StartPage(this));
    addPage(new LoginBrowserPage(this));
    addPage(new LoginDataPage(this));
}

void PluginWizard::setChangedInputs(const QHash<QString, QStringList>& changedInputs)
{
    m_changedInputs = changedInputs;
}

QHash<QString, QStringList> PluginWizard::changedInputs() const
{
    return m_changedInputs;
}
