#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# -----------------------------------------------------------------------------
# 160by2.py, Copyright Bjoern Olausson
# -----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view the license visit
# http://www.gnu.org/licenses/gpl-3.0.html
# or write to
# Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor
# Boston, MA
# 02110-1301 USA
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
#
# Provider written by Bjoern Olausson <maemo@olausson.de>
# with help of Ramkumar M <mramkumar7@gmail.com>
#
# http://160by2.com
# Most likely you are not able to send SMS from outside a certain region
#

__version__ = '2.0.0'
__version_info__ = tuple([int(num) for num in __version__.split('.')])

import urllib2
import re
import cookielib
from urllib import urlencode, quote_plus


class provider():
    def sendSMS(self, LOGIN, PASSWORD, NUMBERS, SMSTEXT, PLUGINDICT):
        LOGIN_URL = "http://160by2.com/re-login"
        SEND_URL = "http://160by2.com/SendSMSAction"

        if not isinstance(SMSTEXT, unicode):
            SMSTEXT = unicode(SMSTEXT, "utf-8")

        POST = {"username": LOGIN,
                "password": PASSWORD,
                "button": "Login"
                }

        # Install a cookie handler and add custom headers
        # Any call to "urlopen" will from now on handle Cookies
        # with cookielib.CookieJar()
        cj = cookielib.CookieJar()
        opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
        header = [('User-agent',
                    'Opera/9.80',
                    )]
        opener.addheaders = header
        urllib2.install_opener(opener)

        try:
            F = urllib2.urlopen(LOGIN_URL, urlencode(POST))
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": str(e.code)
                }, "BALANCE": None}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": str(e.reason)
                }, "BALANCE": None}
            return MSG
        else:
            response = F.read()
            if not re.search(r"%(l)s" % {"l": LOGIN}, response):
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "Login failed"
                    }, "BALANCE": None}
                return MSG

        re_action_value = re.match(r'.*?name="action1" value="(.*?)".*',
                                response,
                                re.DOTALL
                                )
        try:
            action_value = re_action_value.group(1)
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Could not find value for action"
                }, "BALANCE": None}
            return MSG

        try:
            SMS = SMSTEXT.encode("utf-8", "replace")
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": str(e)
                }, "BALANCE": None}
            return MSG

        num = NUMBERS[0]["number"]

        try:
            To = re.match(r"([\+0]*1?)([0-9]*)", num).group(2)
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Could not verify the number"
                }, "BALANCE": None}
            return MSG

        POST = {"hid_exists": "no",
                "action1": action_value,
                "mobile1": To,
                "msg1": SMS,
                }

        try:
            F = urllib2.urlopen(SEND_URL, urlencode(POST))
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": str(e.code)
                }, "BALANCE": None}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": str(e.reason)
                }, "BALANCE": None}
            return MSG
        else:
            response = F.read()
            status = re.match(r'.*?<div class="sent-sms">.*?<h2 ' \
                            'style="text-align: center;">(.*?)</h2>.*',
                            response, re.DOTALL)
            stat = status.group(1).strip()
            if stat == "Your message has been Sent !!!":
                MSG = {"STATUS": {"TYPE": "Success",
                        "MESSAGE": "160by2 responded: %(S)s" % {"S": stat}
                        }, "BALANCE": None}
            else:
                MSG = {"STATUS": {"TYPE": "Error",
                        "MESSAGE": "160by2 responded: %(S)s" % {"S": stat}
                        }, "BALANCE": None}
        return MSG


def plugin_instance():
    return provider()

#
# Uncomment the following and run the plugin directly for testing purpose:
#
#import ConfigParser
#import ast

#config = ConfigParser.ConfigParser()
#config.read('../../plugin_credentials.cfg')

## Which ID to load from the config
#ID = "160by2"

#tLOGIN = config.get(ID, 'LOGIN')
#tPASSWORD = config.get(ID, 'PASSWORD')
#tSMSTEXT = config.get(ID, 'SMSTEXT')
#tNUMBERS = ast.literal_eval(config.get(ID, 'NUMBERS', 0))
#tPLUGINDICT = ast.literal_eval(config.get(ID, 'PLUGINDICT'))

#p = provider()
#r = p.sendSMS(tLOGIN, tPASSWORD, tNUMBERS, tSMSTEXT, tPLUGINDICT)
#print r
