import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0
import "/usr/lib/qt4/imports/com/nokia/meego/UIConstants.js" as UIConstants
import Web2SMS 1.0

Plugin {
    id: container

    // Required! Function to check if all required settings are set
    function isFinished() {
        // Check if the username is entered
        if ( username.text.length == 0 ) {
            //% "Enter voucher code"
            showBanner(qsTrId("qtn_bitesms_no_voucher"));
            return false;
        }

        // Update the display name
        //% "BiteSMS"
        account.displayName = qsTrId("qtn_bitesms_name");
        account.password = username.text;

        return true;
    }

    Label {
        //% "Voucher code"
        text: qsTrId("qtn_bitesms_voucher")
        color: UIConstants.COLOR_INVERTED_SECONDARY_FOREGROUND
    }

    TextField {
        id: username
        width: container.width
        text: account.username

        Binding {
            target: account
            property: "username"
            value: username.text
        }
    }

    Item {
        width: 2
        height: 30
    }

    Label {
        width: container.width
        //% "If you don't have a voucher code, please register at biteSMS.com or munchSMS.com and you'll receive one by SMS."
        text: qsTrId("qtn_bitesms_voucher_info")
    }
}
