#!/bin/env python
# -*- coding: utf-8 -*-
#
# -----------------------------------------------------------------------------
# bitesms.py, Copyright Bjoern Olausson
# -----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view the license visit
# http://www.gnu.org/licenses/gpl-3.0.html
# or write to
# Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor
# Boston, MA
# 02110-1301 USA
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
#
# Provider written by Bjoern Olausson <maemo@olausson.de>
#

__version__ = '1.0.1'
__version_info__ = tuple([int(num) for num in __version__.split('.')])

import urllib2
import re
import HTMLParser
from urllib import urlencode, quote_plus
from time import gmtime, strftime
from lxml import etree


class provider():
    def sendSMS(self, LOGIN, PASSWORD, NUMBERS, SMSTEXT, PLUGINDICT):
        if not isinstance(SMSTEXT, unicode):
            print "SMSTEXT is not a unicode string"
            SMSTEXT = unicode(SMSTEXT, "utf-8")

        URL = "http://smsgateway.bitesms.com/deliver"
        TOKEN = PASSWORD
        ToStr = []
        h = HTMLParser.HTMLParser()

        for item in NUMBERS:
            try:
                n = item["number"].encode('utf8')
                intnum = re.sub(r"^00", "+", n)
                ToStr.append(intnum)
            except Exception, e:
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": e
                    }, "BALANCE": None}

        Sms = etree.Element("sms")
        SmsTimestamp = etree.SubElement(Sms, "timestamp")
        SmsTimestamp.text = strftime("%Y-%m-%d %H:%M:%S +0100", gmtime())

        SmsRecipients = etree.SubElement(Sms, "recipients")
        for num in ToStr:
            SmsTo = etree.SubElement(SmsRecipients, "to")
            SmsTo.text = num

        SmsVouchers = etree.SubElement(Sms, "vouchers")
        SmsToken = etree.SubElement(SmsVouchers, "token")
        SmsToken.text = TOKEN

        SmsMessage = etree.SubElement(Sms, "message")
        SmsMessage.text = SMSTEXT

        #print(etree.tostring(Sms, pretty_print=True))
        xml_req = etree.tostring(Sms, xml_declaration=True, encoding='utf-8')

        try:
            F = urllib2.urlopen(URL, xml_req)
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": str(e.code)
                }, "BALANCE": None}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": str(e.reason)
                }, "BALANCE": None}
            return MSG
        else:
            response = F.read()
            result = etree.XML(response)
            #print(etree.tostring(result, pretty_print=True))
            if re.search("ERROR", response):
                err = re.search(r"<message>(.*?)</message>", response).group(1)
                eru = h.unescape(err).encode('utf-8')
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": eru
                    }, "BALANCE": None}
                return MSG
            else:
                try:
                    BALANCE = re.search(
                        r"<credits-left>([0-9]*?)</credits-left>",
                        response
                        ).group(1)
                except Exception, e:
                    BALANCE = None
                MSG = {"STATUS": {"TYPE": "Success",
                    "MESSAGE": "SMS send"
                    }, "BALANCE": BALANCE}
                return MSG


def plugin_instance():
    return provider()

#
# Uncomment the following and run the plugin directly for testing purpose:
#
#import ConfigParser
#import ast

#config = ConfigParser.ConfigParser()
#config.read('../../plugin_credentials.cfg')

## Which ID to load from the config
#ID = "bitesms"

#tLOGIN = config.get(ID, 'LOGIN')
#tPASSWORD = config.get(ID, 'PASSWORD')
#tSMSTEXT = config.get(ID, 'SMSTEXT')
#tNUMBERS = ast.literal_eval(config.get(ID, 'NUMBERS', 0))
#tPLUGINDICT = ast.literal_eval(config.get(ID, 'PLUGINDICT'))

#p = provider()
#r = p.sendSMS(tLOGIN, tPASSWORD, tNUMBERS, tSMSTEXT, tPLUGINDICT)
#print r
