#!/bin/env python
# -*- coding: utf-8 -*-
#
# -----------------------------------------------------------------------------
# bonbon.py, Copyright Bjoern Olausson
# -----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view the license visit
# http://www.gnu.org/licenses/gpl-3.0.html
# or write to
# Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor
# Boston, MA
# 02110-1301 USA
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
#
# Provider written by Bjoern Olausson <maemo@olausson.de>
# with help of Bojan Komljenović <knobtviker@gmail.com>
#

__version__ = '1.0.0'
__version_info__ = tuple([int(num) for num in __version__.split('.')])

import HTMLParser
import requests
import ast
import re


class provider():
    def getBalance(self, URL, cookies, h):
        POST = {"idart": "171"}

        try:
            r = requests.post(URL, data=POST, cookies=cookies)
        except Exception, e:
            BALANCE = None
        else:
            response = r.content
            response = response.strip()
            response = response.replace("{rows:[", "")
            response = response.replace("}]", "")
            response = ast.literal_eval(response)

            ID = response["ID"]
            ELEMENT = response["ELEMENT"]
            FUNCTION = response["FUNCTION"]
            PAR1 = h.unescape(response["PAR1"])
            PAR2 = h.unescape(response["PAR2"])
            PAR3 = h.unescape(response["PAR3"])
            PAR4 = h.unescape(response["PAR4"])
            PAR5 = h.unescape(response["PAR5"])

            if FUNCTION == "OK":
                try:
                    BALANCE = int(PAR3)
                except Exception, e:
                    BALANCE = None
            else:
                BALANCE = None

        return BALANCE

    def sendSMS(self, LOGIN, PASSWORD, NUMBERS, SMSTEXT, PLUGINDICT):
        LOGIN_URL = "https://www.bonbon.com.hr/corona_sso/bonbon.php"
        SEND_URL = "https://www.bonbon.com.hr/portal/cms/front_content.php"
        LOGOUT_URL = "https://www.bonbon.com.hr/logout"

        BALANCE = None

        h = HTMLParser.HTMLParser()

        if not isinstance(SMSTEXT, unicode):
            SMSTEXT = unicode(SMSTEXT, "utf-8")

        POST = {"username": LOGIN,
                "password": PASSWORD,
                }

        try:
            r = requests.post(LOGIN_URL, data=POST)
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": e
                }, "BALANCE": BALANCE}
        else:
            if not r.ok:
                reason = r.headers['status']
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": reason
                    }, "BALANCE": BALANCE}
                return MSG
            else:
                cookies = r.cookies

                response = r.content.replace("{rows:[", "")
                response = response.replace("}]", "")
                response = ast.literal_eval(response)

                STATUS = response["STATUS"]
                REASON = h.unescape(response["REASON"])
                URL = response["URL"]

                if STATUS != "OK":
                    MSG = {"STATUS": {"TYPE": "Error",
                        "MESSAGE": REASON
                        }, "BALANCE": BALANCE}
                    return MSG


        BALANCE = self.getBalance(SEND_URL, cookies, h)

        nr = NUMBERS[0]["number"].lstrip("00")
        To = "".join([i for i in nr if i.isdigit()])

        POST = {"idart": "107",
                "sms_text": SMSTEXT,
                "sms_recipient": To,
                }
        try:
            r = requests.post(SEND_URL, data=POST, cookies=cookies)
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": e
                }, "BALANCE": BALANCE}
            return MSG
        else:
            if not r.ok:
                reason = r.headers['status']
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": reason
                    }, "BALANCE": BALANCE}
            else:
                response = r.content
                response = response.strip()
                response = response.replace("{rows:[", "")
                response = response.replace("}]", "")
                response = ast.literal_eval(response)

                ID = response["ID"]
                ELEMENT = response["ELEMENT"]
                FUNCTION = response["FUNCTION"]
                PAR1 = h.unescape(response["PAR1"])
                PAR2 = h.unescape(response["PAR2"])
                PAR3 = h.unescape(response["PAR3"])
                PAR4 = h.unescape(response["PAR4"])
                PAR5 = h.unescape(response["PAR5"])

                if FUNCTION == "OK":
                    BALANCE = self.getBalance(SEND_URL, cookies, h)
                    MSG = {"STATUS": {"TYPE": "Success",
                        "MESSAGE": PAR1,
                        }, "BALANCE": BALANCE}
                else:
                    MSG = {"STATUS": {"TYPE": "Error",
                        "MESSAGE": "%(1)s. %(2)s. %(3)s. %(4)s. %(5)s. " %\
                        {"1": PAR1, "2": PAR2, "3": PAR3, "4": PAR4, "5": PAR5}
                        }, "BALANCE": BALANCE}

        try:
            r = requests.get(LOGOUT_URL)
        except Exception, e:
            pass

        return MSG


def plugin_instance():
    return provider()

#
#Uncomment the following and run the plugin directly for testing purpose:
#
#import ConfigParser
#import ast

#config = ConfigParser.ConfigParser()
#config.read('../../plugin_credentials.cfg')

## Which ID to load from the config
#ID = "bonbon"

#tLOGIN = config.get(ID, 'LOGIN')
#tPASSWORD = config.get(ID, 'PASSWORD')
#tSMSTEXT = config.get(ID, 'SMSTEXT')
#tNUMBERS = ast.literal_eval(config.get(ID, 'NUMBERS', 0))
#tPLUGINDICT = ast.literal_eval(config.get(ID, 'PLUGINDICT'))

#p = provider()
#r = p.sendSMS(tLOGIN, tPASSWORD, tNUMBERS, tSMSTEXT, tPLUGINDICT)
#print r
