#!/bin/bash
# Redirect rule for apache
# RedirectMatch ^/(?!plugins(.zip|.tar.bz2|.tar.gz))(.*) https://projects.developer.nokia.com/web2sms/
#

CWD=`pwd`
PLUGIN_PATH="/opt/web2sms/plugins"
ZIP_FILE="/home/web2sms/www/htdocs/plugins.zip"
MD5_FILE="${ZIP_FILE/.zip/.md5}"

cd "${PLUGIN_PATH}"
rm -f "${ZIP_FILE}"
rm timestamp
date +%s > timestamp
zip "${ZIP_FILE}" -r . -i "timestamp" "*.xml" "*.png" "*.qml" "*.qm" > /dev/null
md5sum "${ZIP_FILE}" > "${MD5_FILE}"
cat "${MD5_FILE}"
cd "${CWD}"
