#!/bin/env python
# -*- coding: utf-8 -*-
#
# -----------------------------------------------------------------------------
# ecall_private.py, Copyright Bjoern Olausson
# -----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view the license visit
# http://www.gnu.org/licenses/gpl-3.0.html
# or write to
# Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor
# Boston, MA
# 02110-1301 USA
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
#
# Provider written by Bjoern Olausson <maemo@olausson.de>
#

# Maybe we should use the E-Mail API...
# API documentation:
# http://hilfe.ecall.ch/schnittstellen_email.html
#

__version__ = '1.1.0'
__version_info__ = tuple([int(num) for num in __version__.split('.')])

import re
import mechanize
import HTMLParser


class provider():
    def sendSMS(self, LOGIN, PASSWORD, NUMBERS, SMSTEXT, PLUGINDICT):
        LOGIN_URL = "http://ecall.ch/sms/ecall.asp"
        SEND_URL = "http://www2.ecall.ch/ecall/ecall.ASP?"\
                    "WCI=Message_Create&WCU="
        BALANCE = None

        try:
            SMSTYPE = PLUGINDICT["SMSTYPE"]
        except Exception, e:
            SMSTYPE = "Normal"

        try:
            NOTIFY = PLUGINDICT["NOTIFY"]
        except Exception, e:
            NOTIFY = False

        try:
            BEZAHLUNG = PLUGINDICT["BEZAHLUNG"]
        except Exception, e:
            BEZAHLUNG = "Free"

        if not isinstance(SMSTEXT, unicode):
            SMSTEXT = unicode(SMSTEXT, "utf-8")

        h = HTMLParser.HTMLParser()

        # Instanziate a Browser
        try:
            br = mechanize.Browser()
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
            "MESSAGE": "Failed to initiate the Browser"
            }, "BALANCE": BALANCE}
            return MSG

        #### REQUIRED!!!!
        br.set_handle_robots(False)

        # User-Agent
        UA = 'Opera/9.80 (X11; Linux x86_64; U; en) Version/11.51 Gentoo'
        br.addheaders = [('User-agent', UA)]

        #------------------------------------
        # Open the website
        #------------------------------------
        try:
            br.open(LOGIN_URL)
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Failed to open the ecall website"
                }, "BALANCE": BALANCE}
            return MSG

        #------------------------------------
        # Select the Login form and feed it with the login credentials
        #------------------------------------
        try:
            br.select_form(nr=0)
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Faild to select the login Form"
                }, "BALANCE": BALANCE}
            return MSG

        br.form['AccountName'] = LOGIN
        br.form['Password'] = PASSWORD

        try:
            br.submit()
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": 'Failed to submit login credentials'
                }, "BALANCE": BALANCE}
            return MSG
        else:
            response = br.response().read()
            try:
                WCU = re.match(
                    r'.*?src=".*?WCU=(.*?)".*',
                    response,
                    re.DOTALL
                    ).group(1)
            except Exception, e:
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": 'Failed to find WCU'
                    }, "BALANCE": BALANCE}
                return MSG

        try:
            br.open(SEND_URL + WCU)
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Failed to open the ecall website"
                }, "BALANCE": BALANCE}
            return MSG

        # Get the initial BALANCE
        response = br.response().read()
        VERF = re.match(r".*?Verf&uuml;gbar: (.*?) .*", response, re.DOTALL)
        try:
            BALANCE = VERF.group(1)
        except Exception, e:
            pass

        try:
            br.select_form(nr=0)
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Faild to select the SMS Form"
                }, "BALANCE": BALANCE}
            return MSG

        ToStr = NUMBERS[0]["number"].encode('utf-8')
        TXT = SMSTEXT.encode('utf-8')
        lTXT = len(TXT)
        if lTXT > 120:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Maximum of 120 characters exceeded (%(l)s)" %
                    {"l": lTXT}
                }, "BALANCE": BALANCE}
            return MSG

        if NOTIFY:
            br.form.find_control("chkNotification").items[0].selected = True

        br.form.find_control("CheckFreeNo").items[0].selected = True
        br.form.set_value([SMSTYPE], name='smstype')
        br.form.set_value([BEZAHLUNG], name='UsingUnits')
        br.form['FreeNo'] = ToStr
        br.form['Message'] = SMSTEXT.encode("iso-8859-15")
        br.form['Num'] = str(lTXT)
        br.form['PageNum'] = "1/1"

        try:
            br.submit()
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": 'Failed to submit the form'
                }, "BALANCE": BALANCE}
            return MSG
        else:
            response = br.response().read()
            try:
                err = re.match(
                    r'.*?bgcolor="#FFFF00".*?color="#FF0000".*?<br>(.*?)<.*',
                    response,
                    re.DOTALL,
                    ).group(1)
            except Exception, e:
                try:
                    br.open(SEND_URL + WCU)
                except Exception, e:
                    MSG = {"STATUS": {"TYPE": "Success",
                        "MESSAGE": 'SEND, but could not update balance'
                        }, "BALANCE": BALANCE}
                else:
                    response = br.response().read()
                    VERF = re.match(
                        r".*?Verf&uuml;gbar: (.*?) .*",
                        response,
                        re.DOTALL
                        )
                    try:
                        BALANCE = VERF.group(1)
                    except Exception, e:
                        MSG = {"STATUS": {"TYPE": "Success",
                            "MESSAGE": 'SEND, but could not update balance'
                            }, "BALANCE": BALANCE}
                    else:
                        MSG = {"STATUS": {"TYPE": "Success",
                            "MESSAGE": 'SEND'
                            }, "BALANCE": BALANCE}
            else:
                eru = h.unescape(err).encode('utf-8')
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": eru
                    }, "BALANCE": BALANCE}
            return MSG


def plugin_instance():
    return provider()

#
#Uncomment the following and run the plugin directly for testing purpose:
#
#import ConfigParser
#import ast

#config = ConfigParser.ConfigParser()
#config.read('../../plugin_credentials.cfg')

## Which ID to load from the config
#ID = "ecall_private"

#tLOGIN = config.get(ID, 'LOGIN')
#tPASSWORD = config.get(ID, 'PASSWORD')
#tSMSTEXT = config.get(ID, 'SMSTEXT')
#tNUMBERS = ast.literal_eval(config.get(ID, 'NUMBERS', 0))
#tPLUGINDICT = ast.literal_eval(config.get(ID, 'PLUGINDICT'))

#p = provider()
#r = p.sendSMS(tLOGIN, tPASSWORD, tNUMBERS, tSMSTEXT, tPLUGINDICT)
#print r
