#!/bin/env python
# -*- coding: utf-8 -*-
#
# -----------------------------------------------------------------------------
# o2_ireland.py, Copyright Bjoern Olausson
# -----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view the license visit
# http://www.gnu.org/licenses/gpl-3.0.html
# or write to
# Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor
# Boston, MA
# 02110-1301 USA
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
#
# Provider written by Bjoern Olausson <maemo@olausson.de>
#

__version__ = '1.0.1'
__version_info__ = tuple([int(num) for num in __version__.split('.')])

import urllib2
import cookielib
import re
import time
from math import ceil
from urllib import urlencode, quote_plus


class provider():
    def getBalance(self, WURL):
        try:
            F = urllib2.urlopen(WURL)
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "WURL: " + str(e.code)
                }, "BALANCE": None}
            print MSG
            BALANCE = None
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "WURL: " + str(e.reason)
                }, "BALANCE": None}
            print MSG
            BALANCE = None
        else:
            response = F.read()
            #f = open("compose.html", "w")
            #f.write(response)
            #f.close()
            regex = "You have ([0-9]*?) texts remaining"
            B = re.search(r"%(R)s" % {"R": regex}, response)
            try:
                BALANCE = B.group(1)
            except Exception, e:
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "Failed to get SMS balance"
                    }, "BALANCE": None}
                print MSG
                BALANCE = None

        return BALANCE

    def sendSMS(self, LOGIN, PASSWORD, NUMBERS, SMSTEXT, PLUGINDICT):
        LURL = "https://www.o2online.ie/amserver/UI/Login"
        MURL = "http://messaging.o2online.ie/ssomanager.osp?APIID=AUTH-WEBSSO"
        SURL = "http://messaging.o2online.ie/o2om_smscenter_new.osp?SID=73055_otfeuwos&REF=1226337573&MsgContentID=-1"

        ToStr = NUMBERS[0]["number"]

        # Install a cookie handler and add custom headers
        # Any call to "urlopen" will from now on handle Cookies
        # with cookielib.CookieJar()
        cj = cookielib.CookieJar()
        opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
        header = [('User-agent',
            'Opera/9.80 (X11; Linux x86_64; U; en) Version/11.51 Gentoo',
                    )]
        opener.addheaders = header
        urllib2.install_opener(opener)

        POST = {"IDToken1": LOGIN,
                "IDToken2": PASSWORD,
                "org": "o2ext",
                "goto": MURL,
                "TargetApp": "o2om_smscenter_new.osp?MsgContentID=-1",
                "SID": "_",
                "IDButton": "Go",
                "CONNECTFORMGET": "TRUE"
                }

        try:
            F = urllib2.urlopen(LURL, urlencode(POST))
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "LURL: " + str(e.code)
                }, "BALANCE": None}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "LURL: " + str(e.reason)
                }, "BALANCE": None}
            return MSG
        else:
            response = F.read()
            s = "incorrect"
            if re.search(r"%(S)s" % {"S": s}, response):
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "Login Failed"
                    }, "BALANCE": None}
                return MSG

        BALANCE = self.getBalance(SURL)

        POST = {"to": ToStr,
                "msg": SMSTEXT,
                "chars": num,
                }

        time.sleep(2)
        try:
            F = urllib2.urlopen(SURL, urlencode(POST))
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "SURL: " + str(e.code)
                }, "BALANCE": BALANCE}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "SURL: " + str(e.reason)
                }, "BALANCE": BALANCE}
            return MSG
        else:
            response = F.read()
            if re.search(r"Message Sent Successfully", response):
                BALANCE = self.getBalance(SURL)
                MSG = {"STATUS": {"TYPE": "Success",
                    "MESSAGE": "Message sent"
                    }, "BALANCE": BALANCE}
                return MSG
            else:
                BALANCE = self.getBalance(SURL)
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "Unknown Error"
                    }, "BALANCE": BALANCE}
                return MSG


def plugin_instance():
    return provider()

#
# Uncomment the following and run the plugin directly for testing purpose:
#
#import ConfigParser
#import ast

#config = ConfigParser.ConfigParser()
#config.read('../../plugin_credentials.cfg')

## Which ID to load from the config
#ID = "o2_uk"

#tLOGIN = config.get(ID, 'LOGIN')
#tPASSWORD = config.get(ID, 'PASSWORD')
#tSMSTEXT = config.get(ID, 'SMSTEXT')
#tNUMBERS = ast.literal_eval(config.get(ID, 'NUMBERS', 0))
#tPLUGINDICT = ast.literal_eval(config.get(ID, 'PLUGINDICT'))

#p = provider()
#r = p.sendSMS(tLOGIN, tPASSWORD, tNUMBERS, tSMSTEXT, tPLUGINDICT)
#print r
