#!/bin/env python
# -*- coding: utf-8 -*-
#
# -----------------------------------------------------------------------------
# o2_uk.py, Copyright Bjoern Olausson
# -----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view the license visit
# http://www.gnu.org/licenses/gpl-3.0.html
# or write to
# Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor
# Boston, MA
# 02110-1301 USA
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
#
# Provider written by Bjoern Olausson <maemo@olausson.de>
#

__version__ = '1.0.0'
__version_info__ = tuple([int(num) for num in __version__.split('.')])

import urllib2
import cookielib
import re
import time
from math import ceil
from urllib import urlencode, quote_plus


class provider():
    def getBalance(self, WURL):
        try:
            F = urllib2.urlopen(WURL)
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "WURL: " + str(e.code)
                }, "BALANCE": None}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "WURL: " + str(e.reason)
                }, "BALANCE": None}
            return MSG
        else:
            response = F.read()
            #f = open("compose.html", "w")
            #f.write(response)
            #f.close()
            regex = "You have ([0-9]*?) texts remaining"
            B = re.search(r"%(R)s" % {"R": regex}, response)
            try:
                BALANCE = B.group(1)
            except Exception, e:
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "Failed to get SMS balance"
                    }, "BALANCE": None}
                BALANCE = None
                return MSG

        return BALANCE, TOKEN

    def sendSMS(self, LOGIN, PASSWORD, NUMBERS, SMSTEXT, PLUGINDICT):
        LURL = "https://zarkov.shop.o2.co.uk/login/mblogin"
        CURL = "http://sendtxt.o2.co.uk/sendtxt/action/compose"

        ToStr = NUMBERS[0]["number"]

        # Install a cookie handler and add custom headers
        # Any call to "urlopen" will from now on handle Cookies
        # with cookielib.CookieJar()
        cj = cookielib.CookieJar()
        opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
        header = [('User-agent',
            'Opera/9.80 (X11; Linux x86_64; U; en) Version/11.51 Gentoo',
                    )]
        opener.addheaders = header
        urllib2.install_opener(opener)

        POST = {"USERNAME": LOGIN,
                "PASSWORD": PASSWORD,
                "sendTo": "http://sendtxt.o2.co.uk/sendtxt/action/compose",
                "dest": "http://sendtxt.o2.co.uk/sendtxt/action/compose",
                "fu": "http://www.o2.co.uk/login?error=1",
                }

        try:
            F = urllib2.urlopen(LURL, urlencode(POST))
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "LURL: " + str(e.code)
                }, "BALANCE": None}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "LURL: " + str(e.reason)
                }, "BALANCE": None}
            return MSG
        else:
            response = F.read()
            s = "content\=\'0\;url\=http:\/\/www.o2.co.uk\/login\?error\=1\'"
            if re.search(r"%(S)s" % {"S": s}, response):
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "Login Failed"
                    }, "BALANCE": None}
                return MSG

        BALANCE = self.getBalance(CURL)

        num = 444 - len(SMSTEXT)
        nMessages = ceil(len(SMSTEXT) / 160.0)
        POST = {"compose.to": ToStr,
                        "compose.message": SMSTEXT,
                        "chars": num,
                        "total": nMessages,
                        "compose.paymentType": "free",
                        "execute": "send"
                        }

        time.sleep(2)
        try:
            F = urllib2.urlopen(CURL, urlencode(POST))
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "CURL: " + str(e.code)
                }, "BALANCE": BALANCE}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "CURL: " + str(e.reason)
                }, "BALANCE": BALANCE}
            return MSG
        else:
            response = F.read()
            if re.search(r"Message Sent Successfully", response):
                BALANCE, TOKEN = self.getBalance(CURL)
                MSG = {"STATUS": {"TYPE": "Success",
                    "MESSAGE": "Message sent"
                    }, "BALANCE": BALANCE}
                return MSG
            else:
                BALANCE, TOKEN = self.getBalance(CURL)
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "Unknown Error"
                    }, "BALANCE": BALANCE}
                return MSG


def plugin_instance():
    return provider()

#
# Uncomment the following and run the plugin directly for testing purpose:
#
#import ConfigParser
#import ast

#config = ConfigParser.ConfigParser()
#config.read('../../plugin_credentials.cfg')

## Which ID to load from the config
#ID = "o2_uk"

#tLOGIN = config.get(ID, 'LOGIN')
#tPASSWORD = config.get(ID, 'PASSWORD')
#tSMSTEXT = config.get(ID, 'SMSTEXT')
#tNUMBERS = ast.literal_eval(config.get(ID, 'NUMBERS', 0))
#tPLUGINDICT = ast.literal_eval(config.get(ID, 'PLUGINDICT'))

#p = provider()
#r = p.sendSMS(tLOGIN, tPASSWORD, tNUMBERS, tSMSTEXT, tPLUGINDICT)
#print r
