#!/bin/env python
# -*- coding: utf-8 -*-
#
# -----------------------------------------------------------------------------
# sunrise_swiss.py, Copyright Bjoern Olausson
# -----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view the license visit
# http://www.gnu.org/licenses/gpl-3.0.html
# or write to
# Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor
# Boston, MA
# 02110-1301 USA
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
#
# Provider written by Bjoern Olausson <maemo@olausson.de>
# with help of Luca Vanoni <lvanoni@bluewin.ch>
#

__version__ = '1.0.2'
__version_info__ = tuple([int(num) for num in __version__.split('.')])

import urllib2
import re
import cookielib
from urllib import urlencode, quote_plus


class provider():
    def getInfos(self, URL):
        F = urllib2.urlopen(URL)
        response = F.read()
        s = '.*?Gratis.*?([0-9]+).*?Bezahlt.*?([0-9]+).*'
        balance = re.match(r"%(s)s" % {"s": s}, response, re.DOTALL)
        s = '.*?<input type="hidden" name="currentMsisdn" value="(.*?)"/>.*'
        sender = re.match(r"%(s)s" % {"s": s}, response, re.DOTALL)
        try:
            Msisdn = sender.group(1)
        except Exception, e:
            Msisdn = False
        try:
            freesms = balance.group(1)
        except Exception, e:
            freesms = None
        try:
            payed = balance.group(2)
        except Exception, e:
            payed = False
        return freesms, payed, Msisdn

    def sendSMS(self, LOGIN, PASSWORD, NUMBERS, SMSTEXT, PLUGINDICT):
        URL = "https://mip.sunrise.ch/mip/dyn/login/login"
        GET = "?SAMLRequest=fVJbT8IwFH438T80fd%2FGFmNIw2ZQQyRBXWT44FvpDluhl9n\
Tgf57xwAvD%2FLYr1%2B%2Fy%2BkZ3XxoRbbgUFqT0jgcUAJG2FKaKqWLYhIM6\
U12eTFCrlXDxq2vzQu8t4CedC8Nsv4ipa0zzHKUyAzXgMwLNh8%2FzlgSDljjr\
LfCKkqm9ylV1brmm1oJq5ercmlqa0BxWC91xRsrNnrTiHXDNSWvp1jJPtYUsYW\
pQc%2BN76BBHAdxEsTDIr5iyZAl12%2BU5EenW2kODc7FWh5IyB6KIg%2Fy53n\
RC2xlCe6pY6e0srZSEHZJ9%2FY5R5TbDvauBUrGiOB8l%2B%2FOGmw1uDm4rRS\
weJmltPa%2BQRZFu90u%2FFGJeIStcRK7Ux1xgTTrB8v6bu7XRM8n5ydrmv2Ij\
6JfUtnxw%2FY9pve5VVJ8krFSdnfngPvvEhPrNPf%2Fu8Vh3COyDFY9lbUGGxB\
yJaGkJMoOrn83o9uXLw%3D%3D&RelayState=https%3A%2F%2Fwww.google.\
com%2Fa%2Fsunrise.ch%2FServiceLogin%3Fcontinue%3Dhttp%253A%25\
2F%252Fpartnerpage.google.com%252Fsunrise.ch%252Fdefault%252F\
postlogin%253Fpid%253Dsunrise.ch%2526url%253Dhttp%253A%252F%2\
52Fpartnerpage.google.com%252Fsunrise.ch%26followup%3Dhttp%25\
3A%252F%252Fpartnerpage.google.com%252Fsunrise.ch%252Fdefault\
%252Fpostlogin%253Fpid%253Dsunrise.ch%2526url%253Dhttp%253A%2\
52F%252Fpartnerpage.google.com%252Fsunrise.ch%26service%3Dig%\
26passive%3Dtrue%26cd%3DUS%26hl%3Den%26nui%3D1%26ltmpl%3Ddefa\
ult_gm%26go%3Dtrue%26passive_sso%3Dtrue"

        Widget_URL = 'https://mip.sunrise.ch/mip/dyn/sms/sms?\
up_contactsPerPage=6&lang=en&country=us&.lang=en&.country=us&synd=ig&mid=8&\
ifpctok=-4203269128597452528&exp_track_js=1&exp_ids=25657&\
parent=http://partnerpage.google.com&libs=GGjkAGNfaxw/lib/liberror_tracker.js\
,rco4s8rGdVY/lib/libcore.js,D41s-EJhVGo/lib/libdynamic-height.js&view=home'

        Send_URL = "https://mip.sunrise.ch/mip/dyn/sms/sms?"
        Login_URL = URL + GET

        # Install a cookie handler
        # Any call to "urlopen" will from now on handle Cookies
        # with cookielib.CookieJar()
        cj = cookielib.CookieJar()
        opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
        urllib2.install_opener(opener)

        POST = {"username": LOGIN,
                "password": PASSWORD,
                "_remember": "on"
                }

        try:
            F = urllib2.urlopen(Login_URL, urlencode(POST))
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": str(e.code)
                }, "BALANCE": None}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": str(e.reason)
                }, "BALANCE": None}
            return MSG
        else:
            response = F.read()
            if not re.search(r'document.acsForm.submit\(\);', response):
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "Login Failed"
                    }, "BALANCE": None}
                return MSG
            else:
                FreeSMS, Payed, Msisdn = self.getInfos(Widget_URL)

        if not Msisdn or not Payed or not FreeSMS:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Failt to obtain vital information"
                }, "BALANCE": FreeSMS}
            return MSG

        ToStr = []
        for item in NUMBERS:
            try:
                NA = item["name"].encode('utf8')
            except KeyError:
                ToStr.append(item["number"].encode('utf8'))
            else:
                ToStr.append("%(NAME)s <%(NUMBER)s>" %
                    {"NAME": item["name"].encode('utf8'),
                    "NUMBER": item["number"].encode('utf8'),
                    }
                    )
        nRecipients = len(ToStr)
        To = ", ".join(ToStr)

        if not isinstance(SMSTEXT, unicode):
            SMSTEXT = unicode(SMSTEXT, "utf-8")

        POST = {"task": "send",
            "recipient": To,
            "message": SMSTEXT.encode('utf-8', 'ignore'),
            "type": "sms",
            "currentMsisdn": Msisdn,
            "send": "send",
            }

        try:
            F = urllib2.urlopen(Send_URL, urlencode(POST))
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": str(e.code)
                }, "BALANCE": FreeSMS}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": str(e.reason)
                }, "BALANCE": FreeSMS}
            return MSG
        else:
            response = F.read()
            FreeSMS, Payed, Msisdn = self.getInfos(Widget_URL)

            s = ".*?wurde an (.*?) gesendet.*?"
            sendto = re.findall(r'%(s)s' % {"s": s},
                    response,
                    re.DOTALL
                )

            s = '.*?<span id="errorBlock" class="error">(.*?)<!--.*'
            e = re.match(r'%(s)s' % {"s": s},
                    response,
                    re.DOTALL
                )
            try:
                errm = re.sub(r'[\r\n\t]', '', e.group(1))
            except Exception, e:
                errmsg = "Unknown error (could not read error msg from server)"
            else:
                errmsg = re.sub(r"<br/>\W*", ' ', errm).strip()

            if not sendto:
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": errmsg
                    }, "BALANCE": FreeSMS}
                #f = open("error.html", 'w')
                #f.write(response)
                #f.close()
                return MSG
            else:
                nSendTo = len(sendto)
                if nRecipients != nSendTo:
                    pass
                MSG = {"STATUS": {"TYPE": "Success",
                    "MESSAGE": "Successfully send to %(r)s" %
                        {"r": ", ".join(sendto)}
                    }, "BALANCE": FreeSMS}
                #f = open("success.html", 'w')
                #f.write(response)
                #f.close()
                return MSG


def plugin_instance():
    return provider()

#
#Uncomment the following and run the plugin directly for testing purpose:
#
#import ConfigParser
#import ast

#config = ConfigParser.ConfigParser()
#config.read('../../plugin_credentials.cfg')

## Which ID to load from the config
#ID = "sunrise_swiss"

#tLOGIN = config.get(ID, 'LOGIN')
#tPASSWORD = config.get(ID, 'PASSWORD')
#tSMSTEXT = config.get(ID, 'SMSTEXT')
#tNUMBERS = ast.literal_eval(config.get(ID, 'NUMBERS', 0))
#tPLUGINDICT = ast.literal_eval(config.get(ID, 'PLUGINDICT'))

#p = provider()
#r = p.sendSMS(tLOGIN, tPASSWORD, tNUMBERS, tSMSTEXT, tPLUGINDICT)
#print r
