#!/bin/env python
# -*- coding: utf-8 -*-
#
# -----------------------------------------------------------------------------
# tele2_norway.py, Copyright Bjoern Olausson
# -----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view the license visit
# http://www.gnu.org/licenses/gpl-3.0.html
# or write to
# Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor
# Boston, MA
# 02110-1301 USA
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
#
# Provider written by Bjoern Olausson <maemo@olausson.de>
# with help of Håvard Myklebust (hmyklebust@gmail.com)
#

__version__ = '0.0.1'
__version_info__ = tuple([int(num) for num in __version__.split('.')])

import re
import mechanize
from math import ceil


class provider():
    def sendSMS(self, LOGIN, PASSWORD, NUMBERS, SMSTEXT, PLUGINDICT):
        LoginURL = 'https://www.tele2.no/ajaxMyPages_LoginMobile.html'
        URL = 'https://www.tele2.no/minesider/send-sms.html'

        # set up our browser
        br = mechanize.Browser()
        br.addheaders = [('User-Agent',
            'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.2.3)'
            )]
        #cj = cookielib.LWPCookieJar()
        #br.set_cookiejar(cj)

        # login to provider page
        try:
            br.open(URL)
        except  Exception, msg:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Faile to upen %s" % (LoginURL)
                }, "BALANCE": None}
            return MSG

        try:
            br.select_form(nr=0)
        except  Exception, msg:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Failed to select form"
                }, "BALANCE": None}
            return MSG

        try:
            br.form['user'] = LOGIN
            br.form['pass'] = PASSWORD
            br.submit()
        except  Exception, msg:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Faild to insert form values"
                }, "BALANCE": None}
            return MSG

        # verify login
        response = br.response().read()
        if not re.search(r'ajax-success', response):
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Error logging in"
                }, "BALANCE": None}
            return MSG

        # open "send SMS" site
        try:
            br.open('URL')
        except:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Failed to upen %s" % (URL)
                }, "BALANCE": None}
            return MSG

        response = br.response().read()

        # search site for actual address for
        # sending SMS messages and navigat to it
        addr = 'https://tele2minside.linkmobility.com/SmsSender/SendSms.aspx'
        line = response[response.find(addr):]
        double_quote_index = line.find("\"")
        single_quote_index = line.find("\'")
        end = double_quote_index if single_quote_index == -1 or double_quote_index < single_quote_index else single_quote_index
        sms_addr = line[:end]
        try:
            br.open(sms_addr)
        except:
            MSG = {"STATUS": {"TYPE": "Error",
            "MESSAGE": "Failed to open SMS address"
            }, "BALANCE": None}
            return MSG

        # Find number of free SMS messages left
        response = br.response().read()

        index = response.find("GratisLimit")
        line = response[index:]
        sms_per_day = line[line.find(">") + 1:line.find("<")]

        response = br.response().read()
        index = response.find("AntallGratis")
        line = response[index:]
        sms_sent = line[line.find(">") + 1:line.find("<")]

        try:
            sms_left = "%i" % (int(sms_per_day) - int(sms_sent))
            if sms_left == 0:
                MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Sorry, no more free messages today"
                }, "BALANCE": sms_left}
                return MSG
        except ValueError:
            sms_left = "Unknown"

        # send SMS
        try:
            br.select_form(nr=0)
            br.form['smsrecivers$mottakere'] = NUMBER
            br.form['MessageSMS'] = SMSTEXT

            ctrl_eventtarget = br.find_control(type="hidden", name="__EVENTTARGET")
            ctrl_eventtarget.readonly = False
            ctrl_eventtarget.value = "Send"

            ctrl_eventargument = br.find_control(type="hidden", name="__EVENTARGUMENT")
            ctrl_eventargument.readonly = False
            ctrl_eventargument.value = ""

            br.submit()
        except Exception, msg:
            MSG = {"STATUS": {"TYPE": "Error",
            "MESSAGE": "Error submitting SMS form"
            }, "BALANCE": sms_left}
            return MSG

        # verify that sending worked
        response = br.response().read()
        sms_balance = sms_left - int(ceil(len(SMSTEXT) / 160.0))
        # TODO: check this response (to verify that sending worked)
        MSG = {"STATUS": {"TYPE": "Success",
        "MESSAGE": "Send"
        }, "BALANCE": sms_balance}
        return MSG

def plugin_instance():
    return provider()

#
# Uncomment the following and run the plugin directly for testing purpose:
#
#tLOGIN = "Login"
#tPASSWORD = "Password"
#tSMSTEXT = "This is a test"
#tNUMBERS = [{"number": "+1111111", "name": "AAAAA"},
#           {"number": "+22222", "name": "BBBBB"}
#        ]
#tPLUGINDICT = {}
#
#p = provider()
#r = p.sendSMS(tLOGIN, tPASSWORD, tNUMBERS, tSMSTEXT, tPLUGINDICT)
#print r
