#!/bin/env python
# -*- coding: utf-8 -*-
#
# -----------------------------------------------------------------------------
# vodacom_za.py, Copyright Bjoern Olausson
# -----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view the license visit
# http://www.gnu.org/licenses/gpl-3.0.html
# or write to
# Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor
# Boston, MA
# 02110-1301 USA
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
#
# Provider written by Bjoern Olausson <maemo@olausson.de>
# with help of Muzi Makhudu <>
#

__version__ = '1.0.0'
__version_info__ = tuple([int(num) for num in __version__.split('.')])

import sys
import re
import urllib2
from urllib import urlencode
from urllib import quote_plus
import requests
import cookielib


class provider():
    def getBalance(self, URL, re_freemsg, re_err):
        try:
            F = urllib2.urlopen(URL)
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "HTTPError " + str(e.code)
                }, "BALANCE": None}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "URLError" + str(e.reason)
                }, "BALANCE": None}
            return MSG
        else:
            response = F.read()
            err = re_err.match(response)
            if err:
                MSG = err.group(1).strip()
            else:
                b = re_freemsg.match(response)
                try:
                    B = b.group(1)
                except Exception, e:
                    MSG = {"STATUS": {"TYPE": "Error",
                        "MESSAGE": "Could not find balance"
                        }, "BALANCE": None}
                else:
                    MSG = {"STATUS": {"TYPE": "Success",
                        "MESSAGE": "Got the balance"
                        }, "BALANCE": B}

        return MSG

    def sendSMS(self, LOGIN, PASSWORD, NUMBERS, SMSTEXT, PLUGINDICT):
        POST_LOGIN_URL = "https://www.vodacom.co.za/"\
                        "personal/appmanager/personal/main"
        SMS_URL = "https://www.vodacom.co.za/"\
                "personal/myaccount/sendsms?INITIAL_STATE=INITIAL_STATE"
        POST_SEND_URL = "https://www.vodacom.co.za/"\
                        "personal/appmanager/personal/myaccount"
        BALANCE = None

        try:
            numLOGIN = int(LOGIN)
        except:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Login must only contain numbers"
                }, "BALANCE": BALANCE}

        if not isinstance(SMSTEXT, unicode):
            SMSTEXT = unicode(SMSTEXT, "utf-8")

        re_err = re.compile(r".*?<div class='error'>(.*?)</div>.*",
                            re.DOTALL
                            )
        re_freemsg = re.compile(r'.*?freeMsgLeft">(.*?)</label>.*',
                            re.DOTALL
                            )
        re_suc = re.compile(r".*?<div class='success'>(.*?)</div>.*",
                            re.DOTALL
                            )

        # Install a cookie handler and add custom headers
        # Any call to "urlopen" will from now on handle Cookies
        # with cookielib.CookieJar()
        cj = cookielib.CookieJar()
        opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
        header = [('User-agent', 'Opera/9.80')]
        opener.addheaders = header
        urllib2.install_opener(opener)

        POST = {"username": LOGIN,
                #"passwordtxt": "",
                "password": PASSWORD,
                "_nfpb": "true",
                "_windowLabel": "VodacomCozaMenu_1",
                "_urlType": "action",
                "wlpVodacomCozaMenu_1_ATTR_ACTION_CLASS_NAME":\
                        "za.vsp.portlet.coza.actions.LoginAction",
                }

        try:
            F = urllib2.urlopen(POST_LOGIN_URL, urlencode(POST))
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "HTTPError " + str(e.code)
                }, "BALANCE": BALANCE}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "URLError" + str(e.reason)
                }, "BALANCE": BALANCE}
            return MSG
        else:
            response = F.read()
            err = re_err.match(response)
            if err:
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": err.group(1).strip()
                    }, "BALANCE": BALANCE}
                return MSG

            suc = re.search("<title>My Account</title>", response)
            if not suc:
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "Login failed - Reason unknown"
                    }, "BALANCE": BALANCE}
                return MSG

        MSG = self.getBalance(SMS_URL, re_freemsg, re_err)
        if MSG["STATUS"]["TYPE"] == "Success":
            BALANCE == int(MSG["BALANCE"])
        else:
            return MSG

        ToStr = []
        for item in NUMBERS:
            try:
                n = item["number"].encode('utf8')
                intnum = n.replace("+", "")
                ToStr.append(intnum)
            except Exception, e:
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": e
                    }, "BALANCE": BALANCE}

        To = ";".join(ToStr)

        POST = {"hiddenSelectedRecip": To,
                "hiddenUsedCount": "",
                "HiddenFreeMsgLeft": BALANCE,
                "futurdate": "",
                "addrep": "",
                "addrepname": "",
                "sendSMSnow": "now",
                "messageBody": SMSTEXT.encode("utf-8"),
                "saveSMS": "true",
                "_nfpb": "true",
                "_windowLabel": "T10294390401313659259631",
                "_urlType": "action",
                "wlpT10294390401313659259631_ATTR_ACTION_CLASS_NAME":\
                        "za.vsp.port.portsendsms.action.SendSMSAction",
                "_pageLabel": "sendsms"}

        try:
            F = urllib2.urlopen(POST_SEND_URL, urlencode(POST))
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "HTTPError " + str(e.code)
                }, "BALANCE": BALANCE}
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "URLError" + str(e.reason)
                }, "BALANCE": BALANCE}
        else:
            response = F.read()

            BAL = self.getBalance(SMS_URL, re_freemsg, re_err)
            if BAL["STATUS"]["TYPE"] == "Success":
                    BALANCE = BAL["BALANCE"]

            suc = re_suc.match(response)
            err = re_err.match(response)
            if suc:
                MSG = {"STATUS": {"TYPE": "Success",
                    "MESSAGE": suc.group(1).strip()
                    }, "BALANCE": BALANCE}
                return MSG
            elif err:
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "Send status: " + err.group(1).strip()
                    }, "BALANCE": BALANCE}
            else:
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "Sending failed - Unknown reason"
                    }, "BALANCE": BALANCE}
        return MSG


def plugin_instance():
    return provider()

#
#Uncomment the following and run the plugin directly for testing purpose:
#
#import ConfigParser
#import ast

#config = ConfigParser.ConfigParser()
#config.read('../../plugin_credentials.cfg')

## Which ID to load from the config
#ID = "vodacom_za"

#tLOGIN = config.get(ID, 'LOGIN')
#tPASSWORD = config.get(ID, 'PASSWORD')
#tSMSTEXT = config.get(ID, 'SMSTEXT')
#tNUMBERS = ast.literal_eval(config.get(ID, 'NUMBERS', 0))
#tPLUGINDICT = ast.literal_eval(config.get(ID, 'PLUGINDICT'))

#p = provider()
#r = p.sendSMS(tLOGIN, tPASSWORD, tNUMBERS, tSMSTEXT, tPLUGINDICT)
#print r
