#!/bin/env python
# -*- coding: utf-8 -*-
#
# -----------------------------------------------------------------------------
# vodafone_netherlands.py, Copyright Bjoern Olausson
# -----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view the license visit
# http://www.gnu.org/licenses/gpl-3.0.html
# or write to
# Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor
# Boston, MA
# 02110-1301 USA
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
#
# Provider written by Bjoern Olausson <maemo@olausson.de>
# with help of Shane Kerr <shane@time-travellers.org>
#

__version__ = '1.0.0'
__version_info__ = tuple([int(num) for num in __version__.split('.')])

import re
import mechanize


class provider():
    def sendSMS(self, LOGIN, PASSWORD, NUMBERS, SMSTEXT, PLUGINDICT):
        # TODO: check whether sending worked
        # TODO: handle "2 per day maximum"
        # TODO: localization support (at least English and Dutch)
        BASE_URL = "https://my.vodafone.nl"
        LOGIN_URL = BASE_URL + "/prive/my_vodafone"
        SEND_URL = BASE_URL + "/Prive/My_Vodafone/gratis_sms_versturen"

        if not isinstance(SMSTEXT, unicode):
            SMSTEXT = unicode(SMSTEXT, "utf-8")

        BALANCE = None

        br = mechanize.Browser()
        #cj = cookielib.LWPCookieJar()
        #br.set_cookiejar(cj)

        # login
        try:
            br.open(LOGIN_URL)
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Failed to open the website"
                }, "BALANCE": BALANCE}
            return MSG

        try:
            br.select_form(name='login')
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Faild to select the login form"
                }, "BALANCE": BALANCE}
            return MSG

        try:
            br.form['username'] = LOGIN
            br.form['password'] = PASSWORD
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Faild to fill the login form"
                }, "BALANCE": BALANCE}
            return MSG

        try:
            br.submit()
            br.response().read()
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": 'Failed to submit login form'
                }, "BALANCE": BALANCE}
            return MSG

        # verify our login worked and return error if not
        try:
            br.find_link(text='Uitloggen')
        except mechanize.LinkNotFoundError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": 'Login failed'
                }, "BALANCE": BALANCE}
            return MSG

        # send the SMS
        try:
            br.open(SEND_URL)
            response = br.response().read()
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": 'Failed to load SMS page'
                }, "BALANCE": BALANCE}
            return MSG

        s = 'Je hebt het maximum aantal gratis SMS\'jes bereikt voor vandaag.'
        if re.search(r'%(s)s' % {"s": s}, response):
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Provider responded: Je hebt het maximum aantal " \
                "gratis SMS'jes bereikt voor vandaag."
                }, "BALANCE": BALANCE}
            return MSG

        try:
            br.select_form(name='controle')
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Faild to select the controle form"
                }, "BALANCE": BALANCE}
            return MSG

        try:
            br.form['phoneNumber'] = number
            br.form['body'] = SMSTEXT.encode(br.encoding())
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Faild to fill the controle form"
                }, "BALANCE": BALANCE}
            return MSG

        try:
            br.submit()
            response = br.response().read()
        except Exception, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Error submitting SMS form"
                }, "BALANCE": BALANCE}
            return MSG

        # check to see if our send worked
        s1 = "Je sms\'je is verstuurd."
        s2 = "Je hebt het maximum aantal gratis "\
            "SMS\'jes voor vandaag verstuurd."
        if re.search(r'%(s)s' % {"s1": s}, response):
            MSG = {"STATUS": {"TYPE": "Success",
                "MESSAGE": s1
                }, "BALANCE": BALANCE}
        elif re.search(r'%(s)s' % {"s2": s}, response):
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": s2
                }, "BALANCE": BALANCE}
            return MSG
        else:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "Message not sent"
                }, "BALANCE": BALANCE}
            return MSG


def plugin_instance():
    return provider()

#
# Uncomment the following and run the plugin directly for testing purpose:
#
#import ConfigParser
#import ast

#config = ConfigParser.ConfigParser()
#config.read('../../plugin_credentials.cfg')

## Which ID to load from the config
#ID = "vodafone_netherlands"

#tLOGIN = config.get(ID, 'LOGIN')
#tPASSWORD = config.get(ID, 'PASSWORD')
#tSMSTEXT = config.get(ID, 'SMSTEXT')
#tNUMBERS = ast.literal_eval(config.get(ID, 'NUMBERS', 0))
#tPLUGINDICT = ast.literal_eval(config.get(ID, 'PLUGINDICT'))

#p = provider()
#r = p.sendSMS(tLOGIN, tPASSWORD, tNUMBERS, tSMSTEXT, tPLUGINDICT)
#print r
