#!/bin/env python
# -*- coding: utf-8 -*-
#
# -----------------------------------------------------------------------------
# vodafonesms_czech-republic.py, Copyright Bjoern Olausson
# -----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view the license visit
# http://www.gnu.org/licenses/gpl-3.0.html
# or write to
# Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor
# Boston, MA
# 02110-1301 USA
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
#
# Provider written by Bjoern Olausson <maemo@olausson.de>
# with help of Jan Kratochvil <jan@jankratochvil.net>
#

__version__ = '1.0.0'
__version_info__ = tuple([int(num) for num in __version__.split('.')])

import urllib2
import re
import cookielib
from urllib import urlencode

class provider():
    def sendSMS(self, LOGIN, PASSWORD, NUMBERS, SMSTEXT, PLUGINDICT):
        URL = 'https://park.vodafone.cz/'
        ToStr = NUMBERS[0]["number"]

        LOGINURL = URL + "login"
        POST = {"email": LOGIN, "password": PASSWORD}

        if not isinstance(SMSTEXT, unicode):
            SMSTEXT = unicode(SMSTEXT, "utf-8")

        # Install a cookie handler
        # Any call to "urlopen" will from now on handle Cookies
        # with cookielib.CookieJar()
        cj = cookielib.CookieJar()
        opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
        urllib2.install_opener(opener)

        try:
            F = urllib2.urlopen(LOGINURL, urlencode(POST))
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "HTTPError LOGINURL: " + str(e.code)
                }, "BALANCE": None}
            return MSG
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "URLError LOGINURL: " + str(e.reason)
                }, "BALANCE": None}
            return MSG
        else:
            response = F.read()
            if not re.search(r'class="logout"', response):
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "Login Failed"
                    }, "BALANCE": None}
                return MSG
            else:
                SID = re.search(r"name=\"sendButton\".*x=(.*)',", response).group(1)

        SENDURL = URL + "gateway?x=" + SID

        POST = {"recipients:recipientInput": ToStr,
                "text": SMSTEXT.encode("utf-8"),
                }

        try:
            F = urllib2.urlopen(SENDURL, urlencode(POST))
        except urllib2.URLError, e:
            MSG = {"STATUS": {"TYPE": "Error",
                "MESSAGE": "URLError SENDURL " + str(e.code)
                }, "BALANCE": None}
            return MSG
        except urllib2.HTTPError, e:
            MSG = {"STATUS": {"TYPE": "Error",
            "MESSAGE": "HTTPError SENDURL " + str(e.reason)
            }, "BALANCE": None}
            return MSG
        else:
            response = F.read()
            if re.search(r"Zpráva byla úspěšně odeslána", response):
                MSG = {"STATUS": {"TYPE": "Success",
                "MESSAGE": "SMS send"
                }, "BALANCE": None}
                return MSG
            else:
                MSG = {"STATUS": {"TYPE": "Error",
                    "MESSAGE": "SMS not send"
                    }, "BALANCE": None}
                return MSG

def plugin_instance():
    return provider()

#
# Uncomment the following and run the plugin directly for testing purpose:
#
#tLOGIN = "Login"
#tPASSWORD = "Password"
#tSMSTEXT = "This is a test"
#tNUMBERS = [{"number": "+1111111", "name": "AAAAA"},
#           {"number": "+22222", "name": "BBBBB"}
#        ]
#tPLUGINDICT = {}
#
#p = provider()
#r = p.sendSMS(tLOGIN, tPASSWORD, tNUMBERS, tSMSTEXT, tPLUGINDICT)
#print r
