import QtQuick 1.1
import com.nokia.meego 1.0
import "/usr/lib/qt4/imports/com/nokia/meego/UIConstants.js" as UIConstants
import Web2SMS 1.0

Plugin {
    id: container

    Component.onCompleted: {
        if ( pluginName.length == 0 ) {
            var provider = backend.plugins.providerById(account.providerId);
            console.log("Loaded default provider:", provider);
            pluginName = qsTrId(provider.name);
            pluginDescription = qsTrId(provider.description);
        }
    }

    // Required! Function to check if all required settings are set
    function isFinished() {
        // Check if the username is entered
        if ( username.text.length == 0 ) {
            //% "Enter username"
            showBanner(qsTrId("qtn_web2sms_genericaccountsettings_banner_enter_username"));
            return false;
        }

        // Check if the password is entered
        if ( password.text.length == 0 ) {
            //% "Enter password"
            showBanner(qsTrId("qtn_web2sms_genericaccountsettings_banner_enter_password"));
            return false;
        }

        // Change the account name
        account.displayName = username.text + " | " + pluginName;

        return true;
    }

    Label {
        //% "Username"
        text: qsTrId("qtn_web2sms_genericaccountsettings_label_username")
        color: UIConstants.COLOR_INVERTED_SECONDARY_FOREGROUND
    }

    TextField {
        id: username
        width: container.width
        text: account.username

        Binding {
            target: account
            property: "username"
            value: username.text
        }
    }

    Label {
        //% "Password"
        text: qsTrId("qtn_web2sms_genericaccountsettings_label_password")
        color: UIConstants.COLOR_INVERTED_SECONDARY_FOREGROUND
    }

    TextField {
        id: password
        width: container.width
        echoMode: TextInput.Password
        text: account.password

        Binding {
            target: account
            property: "password"
            value: password.text
        }
    }
}
