import QtQuick 1.1
import com.nokia.meego 1.0

PageStackWindow {
    id: appWindow
    Component.onCompleted: {
        // We want the cool inverted theme
        theme.inverted = true;

        // Lock us to portrait
        //screen.allowedOrientations = Screen.Portrait;
        //screen.allowedOrientations = Screen.Landscape;

        var component = null;

        // Choose which page is the initial one
        if ( setupType == "Unset" ) {
            component = Qt.createComponent("StandalonePage.qml");

            var properties = {
                "hasBackButton":false
            };

            var page = component.createObject(parent, properties);
            pageStack.push(page);
        }
        else if ( setupType == "CreateNew" ){
            component = Qt.createComponent("ProviderSelectionPage.qml");

            var properties = {
                "setupType":setupType,
                "quitWhenCreated":true
            };

            var page = component.createObject(parent, properties);
            pageStack.push(page);
            return;

        } else {
            component = Qt.createComponent("EditAccountPage.qml");

            var parameters = {
                "setupType":setupType,
                "account":backend.account
            };

            // Create the page object and set it up
            var page = component.createObject(parent, parameters);
            page.finished.connect(Qt.quit);
            pageStack.push(page);
            return;
        }

        if ( component.status == Component.Ready )
            pageStack.push(component);
        else
            console.log("Error loading component:", component.errorString());
    }
}
