// Local includes
#include "accountsmodel.h"

// Global includes
#include <QDebug>

class AccountsModelPrivate {
public:
    QString providerFilter;
};

AccountsModel::AccountsModel(QObject *parent)
: QAbstractListModel(parent)
, d(new AccountsModelPrivate)
{
}

AccountsModel::~AccountsModel()
{
    delete d;
}

void AccountsModel::setProviderFilter(const QString &providerFilter)
{
    if ( d->providerFilter == providerFilter )
        return;

    d->providerFilter = providerFilter;
    emit providerFilterChanged();
}

QString AccountsModel::providerFilter() const
{
    return d->providerFilter;
}

Accounts::Account* AccountsModel::account(int row) const
{
    Q_UNUSED(row);
    return NULL;
}

int AccountsModel::indexFromAccountId(quint32 accountId) const
{
    return 0;
}

int AccountsModel::rowCount(const QModelIndex &parent) const
{
    if ( parent.isValid() )
        return 0;

    return 1;
}

QVariant AccountsModel::data(const QModelIndex &index, int role) const
{
    switch(role)
    {
    case DisplayNameRole:
        return "DisplayName";

    case IdRole:
        return 0;

    case EnabledRole:
        return true;

    case ProviderIdRole:
        return "o2_germany";

    case UsernameRole:
        return "username";

    case AccountRole:
        break;
    }

    return QVariant();
}

int AccountsModel::count() const
{
    return rowCount();
}

void AccountsModel::classBegin()
{
}

void AccountsModel::componentComplete()
{
}
