#ifndef AVATARIMAGE_H
#define AVATARIMAGE_H

// Local includes
#include "global.h"

// Global includes
#include <QDeclarativeItem>

class AvatarImagePrivate;

class WEB2SMS_API AvatarImage : public QDeclarativeItem
{
    Q_OBJECT
    Q_PROPERTY(int contactId READ contactId WRITE setContactId NOTIFY contactIdChanged)

public:
    explicit AvatarImage(QDeclarativeItem *parent = 0);
    ~AvatarImage();

    void setContactId(int contactId);
    int contactId() const;

    // QDeclarativeItem overrides
    void classBegin();
    void paint(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget);

signals:
    void contactIdChanged();

protected:
    AvatarImagePrivate* d;
};

#endif // AVATARIMAGE_H
