#include "clipboard.h"

#include <QApplication>
#include <QClipboard>

Clipboard::Clipboard(QObject *parent)
: QObject(parent)
{
    QClipboard* clipboard = QApplication::clipboard();
    connect(clipboard, SIGNAL(dataChanged()), this, SIGNAL(textChanged()));
}

void Clipboard::setText(const QString &text)
{
    QClipboard* clipboard = QApplication::clipboard();
    clipboard->setText(text);
}

QString Clipboard::text() const
{
    QClipboard* clipboard = QApplication::clipboard();
    return clipboard->text();
}
