// Local includes
#include "contactpicker.h"

// Global includes
#include <QDebug>

#ifndef Q_OS_ANDROID
#include <QDBusMessage>
#include <QDBusInterface>
#endif // Q_OS_ANDROID

/// Information taken from:
/// http://gitorious.org/qtcontacts-tracker/qtcontacts-tracker/blobs/master/src/lib/settings.cpp#line88

ContactHelper::ContactHelper(QObject *parent)
: QObject(parent)
, m_contactSettings(QSettings::IniFormat, QSettings::UserScope,
                    QLatin1String("Nokia"), QLatin1String("Contacts"))
{
}

ContactHelper::~ContactHelper()
{
}

void ContactHelper::openContactCard(int id)
{
#ifndef Q_OS_ANDROID
    // Sanity checks
    if ( id <= 0 )
        return;

    QDBusInterface iface("com.nokia.contacts", "/", "com.nokia.maemo.meegotouch.ContactsInterface");

    QDBusMessage msg = iface.call("openContactCard", QVariant::fromValue(id));
    qDebug() << Q_FUNC_INFO << id << msg.errorMessage();
#endif // Q_OS_ANDROID
}

ContactHelper::NameOrder ContactHelper::nameOrder() const
{
    // Get the string representation of the order
    QString order = m_contactSettings.value("nameOrder", "first-last").toString();

    // Do a simple comparation
    if ( order == "last-first" )
        return LastFirst;
    else
        return FirstLast;
}
