#ifndef CONTACTPICKER_H
#define CONTACTPICKER_H

// Local includes
#include "global.h"

// Global includes
#include <QSettings>

class WEB2SMS_API ContactHelper : public QObject
{
    Q_OBJECT
    Q_ENUMS(NameOrder)
    Q_PROPERTY(int nameOrder READ nameOrder CONSTANT)

public:
    explicit ContactHelper(QObject *parent = 0);
    ~ContactHelper();

    enum NameOrder
    {
        FirstLast, // Firstname - Lastname
        LastFirst  // Lastname - Firstname
    };

    Q_INVOKABLE void openContactCard(int id);

    NameOrder nameOrder() const;

protected:
    QSettings m_contactSettings;
};

#endif // CONTACTPICKER_H
