TEMPLATE = lib
TARGET = web2sms

# Compile the package version into the binary
PACKAGEVERSION = $$system(head -n 1 ../qtc_packaging/debian_harmattan/changelog | grep -o [0-9].[0-9].[0-9])
DEFINES += "PACKAGEVERSION=\\\"$$PACKAGEVERSION\\\""

DEFINES += WEB2SMS_BUILD

QT += declarative network
!android: QT += dbus

CONFIG += qt \
          mobility \
          link_pkgconfig

MOBILITY += contacts

android {
    INCLUDEPATH += ../../qjson/include
    LIBS += -L../../qjson/lib -lqjson
} else {
    PKGCONFIG += QJson
}

# Add some Harmattan API
contains(MEEGO_EDITION, harmattan) {
    QMAKE_CXXFLAGS += -Wno-psabi

    DEFINES += MEEGO_EDITION_HARMATTAN
    CONFIG += ovinotifications

    PKGCONFIG += accounts-qt \
                 libsignon-qt \
                 commhistory \
                 AccountSetup \
                 contextprovider-1.0

    # Notifications API
    ONEINCLUDE = $$QMAKE_INCDIR_QT/../one
    INCLUDEPATH += /usr/include/one $$ONEINCLUDE

    SOURCES += groupmodel_meego.cpp \
               conversationmodel_meego.cpp \
               accountwrapper_meego.cpp \
               accountsmodel_meego.cpp
}

maemo5 {
    PKGCONFIG += libosso-abook-1.0 \
                 libosso \
                 rtcom-eventlogger \
                 glib-2.0 \
                 gtk+-2.0 \
                 hildon-1 \
                 conic

    SOURCES += groupmodel_maemo5.cpp \
               conversationmodel_maemo5.cpp \
               accountwrapper_maemo5.cpp \
               accountsmodel_maemo5.cpp
}

android {
    SOURCES += groupmodel_android.cpp \
               conversationmodel_android.cpp \
               accountwrapper_android.cpp \
               accountsmodel_android.cpp
}

# Statically link quazip
include(../../quazip-0.4.4/quazip/quazip.pri)
DEFINES += QUAZIP_STATIC
LIBS += -lz

# Input
SOURCES += \
    pluginresolver.cpp \
    providerinfo.cpp \
    providersmodel.cpp \
    contactpicker.cpp \
    clipboard.cpp \
    backend.cpp \
    messagestatistics.cpp \
    qgsmcodec.cpp \
    messagetype.cpp \
    messagehandler.cpp \
    zipfilesystem.cpp \
    avatarimage.cpp \
    contactmodel.cpp

HEADERS += \
    pluginresolver.h \
    providerinfo.h \
    providersmodel.h \
    groupmodel.h \
    conversationmodel.h \
    contactpicker.h \
    clipboard.h \
    backend.h \
    accountwrapper.h \
    accountsmodel.h \
    messagestatistics.h \
    qgsmcodec.h \
    messagetype.hpp \
    messagehandler.h \
    global.h \
    zipfilesystem.h \
    avatarimage.h \
    contactmodel.h

OTHER_FILES = net.muhkuh.web2sms.Context.context

contextkit.files = $$files(*.context)
contextkit.path = /usr/share/contextkit/providers
INSTALLS += contextkit

target.path = /opt/web2sms/lib
INSTALLS += target

exists(../api_key.pri) {
    include(../api_key.pri)
} else {
    error("Using default api key values. Uncomment this line if you are sure you want this.")

    DEFINES += "API_SERVER=\\\"\\\"" \
               "API_KEY_L=0" \
               "API_KEY_W1=0" \
               "API_KEY_W2=0" \
               "API_KEY_B1=0" \
               "API_KEY_B2=0" \
               "API_KEY_B3=0" \
               "API_KEY_B4=0" \
               "API_KEY_B5=0" \
               "API_KEY_B6=0" \
               "API_KEY_B7=0" \
               "API_KEY_B8=0"
}
