#ifndef MESSAGETYPE_HPP
#define MESSAGETYPE_HPP

// Local includes
#include "global.h"

// Global includes
#include <QtCore/QSharedDataPointer>
#include <QtCore/QMetaType>
#include <QtGui/QIcon>

// Forward declarations
class MessageTypeData;

class WEB2SMS_API MessageType : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QString visibleName READ visibleName)
    Q_PROPERTY(QString name READ name)
    Q_PROPERTY(int singleMessageLength READ singleMessageLength)
    Q_PROPERTY(int maxMessageLength READ maxMessageLength)
    Q_PROPERTY(int maxReceivers READ maxReceivers)

public:
    explicit MessageType(const QString& visibleName,
                         const QString& name,
                         const QIcon& icon,
                         const QString& information,
                         int singleMessageLength,
                         int maxMessageLength,
                         int maxReceivers);
    ~MessageType();

    QString visibleName() const;
    QString name() const;
    QIcon icon() const;
    QString information() const;
    int singleMessageLength() const;
    int maxMessageLength() const; // -1 == infinite
    int maxReceivers() const;

private:
  QSharedDataPointer<MessageTypeData> data;
};

#endif // MESSAGETYPE_HPP
