#ifndef PROVIDERSMODEL_H
#define PROVIDERSMODEL_H

// Local includes
#include "global.h"

// Global includes
#include <QtCore/QAbstractListModel>
#include <QtDeclarative/QDeclarativeParserStatus>

// Forward declarations
class ProvidersModelPrivate;

class WEB2SMS_API ProvidersModel : public QAbstractListModel
                                 , public QDeclarativeParserStatus
{
    Q_OBJECT
    Q_INTERFACES(QDeclarativeParserStatus)

public:
    explicit ProvidersModel(QObject *parent = 0);
    ~ProvidersModel();

    enum Roles
    {
        TitleRole = Qt::UserRole+1,
        SubtitleRole,
        IconSourceRole,
        ProviderIdRole,
        AccountSetupRole,
        BalanceFormatRole
    };

    // QAbstractListModel overrides
    int rowCount(const QModelIndex &parent = QModelIndex()) const;
    QVariant data(const QModelIndex &index, int role) const;

    // QDeclarativeParserStatus overrides
    void classBegin();
    void componentComplete();

protected:
    friend class ProvidersModelPrivate;
    ProvidersModelPrivate* d;
};

#endif // PROVIDERSMODEL_H
