import QtQuick 1.1
import com.nokia.meego 1.0
import Web2SMS 1.0
import "/usr/lib/qt4/imports/com/nokia/meego/UIConstants.js" as UIConstants
import "/usr/lib/qt4/imports/com/nokia/extras/constants.js" as ExtrasConstants

/*

  Most of this code is a copy of "Butaca: Cinema information" by Simon Pena, licensed under GPL.

  https://gitorious.org/butaca/butaca/blobs/master/src/qml/AboutView.qml

 */

Page {
    property string license: 'This program is free software: you can redistribute it and/or modify ' +
        'it under the terms of the GNU General Public License as published by ' +
        'the Free Software Foundation, either version 3 of the License, or ' +
        '(at your option) any later version.<br /><br />' +

        'This package is distributed in the hope that it will be useful, ' +
        'but WITHOUT ANY WARRANTY; without even the implied warranty of ' +
        'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the ' +
        'GNU General Public License for more details.<br /><br />' +

        'You should have received a copy of the GNU General Public License ' +
        'along with this program. If not, see ' +
        '<a href="http://www.gnu.org/licenses">http://www.gnu.org/licenses</a><br /><br />'

    property string credits: 'Icon by Frederico Santos<br/>' +
                             'Twitter: <a href="http://twitter.com/#!/fredericosantos">@fredericosantos</a><br/>' +
                             '<br/>' +
                             'L10n credits:<br/>' +
                             '<ul>'+
                             '<li>Christoph Keller - German (de)</li>' +
                             '<li>Simon Pena - Spanish (es)</li>' +
                             '<li>Leonardo Echeverria - Spanish (es)</li>' +
                             '<li>David Wulliamoz - French (fr)</li>' +
                             '</ul>'

    tools: ToolBarLayout {
        ToolIcon {
            id: backIcon
            iconId: 'toolbar-back'
            onClicked: pageStack.pop()
        }
    }
    orientationLock: PageOrientation.LockPortrait

    Flickable {
        id: flick
        anchors.fill: parent
        anchors {
            topMargin: UIConstants.HEADER_DEFAULT_TOP_SPACING_PORTRAIT
            leftMargin: UIConstants.DEFAULT_MARGIN
            rightMargin: UIConstants.DEFAULT_MARGIN
        }

        contentHeight: contentColumn.height

        Column {
            id: contentColumn
            spacing: UIConstants.DEFAULT_MARGIN
            width: parent.width

            Image {
                id: aboutImage
                anchors.horizontalCenter: parent.horizontalCenter
                source: "/usr/share/themes/blanco/meegotouch/icons/icon-l-web2sms.png"
            }

            Text {
                id: aboutVersion
                text: 'Web2SMS ' + appVersion
                anchors.horizontalCenter: parent.horizontalCenter
                font.pixelSize: UIConstants.FONT_XLARGE
                font.family: UIConstants.FONT_FAMILY
                color: !theme.inverted ?
                           UIConstants.COLOR_FOREGROUND :
                           UIConstants.COLOR_INVERTED_FOREGROUND
            }

            Text {
                id: aboutCopyright
                text: 'Copyright © 2011 - 2012'
                anchors.horizontalCenter: parent.horizontalCenter
                font.pixelSize: UIConstants.FONT_LARGE
                font.family: "Nokia Pure Text Light"
                color: !theme.inverted ?
                           UIConstants.COLOR_FOREGROUND :
                           UIConstants.COLOR_INVERTED_FOREGROUND
            }

            Text {
                text: 'Christoph Keller and Bjoern Olausson'
                anchors.horizontalCenter: parent.horizontalCenter
                font.pixelSize: UIConstants.FONT_LARGE
                font.family: "Nokia Pure Text Light"
                color: !theme.inverted ?
                           UIConstants.COLOR_FOREGROUND :
                           UIConstants.COLOR_INVERTED_FOREGROUND
            }

            Text {
                id: aboutContact
                anchors.horizontalCenter: parent.horizontalCenter
                font.pixelSize: UIConstants.FONT_LSMALL
                font.family: UIConstants.FONT_FAMILY
                color: !theme.inverted ?
                           UIConstants.COLOR_FOREGROUND :
                           UIConstants.COLOR_INVERTED_FOREGROUND
                text: '<a href="mailto:web2sms@olausson.de">web2sms@olausson.de</a> | ' +
                      '<a href="http://projects.developer.nokia.com/web2sms">Project Page</a>'
                onLinkActivated: Qt.openUrlExternally(link)
            }

            /*Item {
                id: aboutThemovieDb
                width: parent.width
                height: childrenRect.height

                Image {
                    id: aboutThemovieDbImage
                    anchors.top: parent.top
                    source: 'qrc:/resources/tmdb-logo.png'
                }

                Text {
                    id: aboutThemovieDbDisclaimer
                    anchors.top: aboutThemovieDbImage.bottom
                    font.pixelSize: UIConstants.FONT_LSMALL
                    font.family: UIConstants.FONT_FAMILY
                    color: !theme.inverted ?
                               UIConstants.COLOR_FOREGROUND :
                               UIConstants.COLOR_INVERTED_FOREGROUND
                    width: parent.width
                    wrapMode: Text.WordWrap
                    //: This product uses the <a href="http://www.themoviedb.org/">TMDb</a> API but is not endorsed or certified by TMDb.
                    text: qsTr('btc-themoviedb-disclaimer')
                    onLinkActivated: Qt.openUrlExternally(link)
                }
            }*/

            Text {
                font.pixelSize: UIConstants.FONT_LSMALL
                font.family: UIConstants.FONT_FAMILY
                color: !theme.inverted ?
                           UIConstants.COLOR_FOREGROUND :
                           UIConstants.COLOR_INVERTED_FOREGROUND
                width: parent.width
                wrapMode: Text.WordWrap
                //% "If you wish to participate, report bugs or new ideas, please visit the project page."
                text: qsTrId("qtn_web2sms_about_help")
                onLinkActivated: Qt.openUrlExternally(link)
            }

            Text {
                font.pixelSize: UIConstants.FONT_LSMALL
                font.family: UIConstants.FONT_FAMILY
                color: !theme.inverted ?
                           UIConstants.COLOR_FOREGROUND :
                           UIConstants.COLOR_INVERTED_FOREGROUND
                width: parent.width
                wrapMode: Text.WordWrap
                //% "This product uses various SMS service APIs but is not endorsed or certified by them. Check <a href='https://gitorious.org/web2sms/plugins'>the code</a> for details."
                text: qsTrId("qtn_web2sms_about_service_disclaimer")
                onLinkActivated: Qt.openUrlExternally(link)
            }

            Button {
                anchors.horizontalCenter: parent.horizontalCenter
                //% "Credits"
                text: qsTrId("qtn_web2sms_about_credits")
                onClicked: {
                    dialog.titleText = qsTrId("qtn_web2sms_about_credits")
                    dialog.message = credits
                    dialog.open()
                }
            }

            Button {
                anchors.horizontalCenter: parent.horizontalCenter
                //% "License"
                text: qsTrId("qtn_web2sms_about_license")
                onClicked: {
                    dialog.titleText = qsTrId("qtn_web2sms_about_license")
                    dialog.message = license
                    dialog.open()
                }
            }
        }
    }

    ScrollDecorator {
        flickableItem: flick
        anchors.rightMargin: -UIConstants.DEFAULT_MARGIN
    }

    QueryDialog {
        id: dialog
        //% "OK"
        acceptButtonText: qsTrId("qtn_web2sms_ok")
    }
}
