import QtQuick 1.1
import com.nokia.meego 1.0
import "/usr/lib/qt4/imports/com/nokia/meego/UIConstants.js" as UIConstants

Item {
    function createAccount() {
        var component = Qt.createComponent("/opt/web2sms/accounts/ProviderSelectionPage.qml");

        if ( component.status != Component.Ready ) {
            console.log("Error creating component:", component.errorString());
            return;
        }

        var properties = {
            "setupType":"Unset"
        };

        var page = component.createObject(parent, properties);
        // TODO: Note this key somewhere, this may be confusing!
        page.parentPage = groupPage;
        pageStack.push(page);
    }

    function createAccountWithProvider(providerId) {
        var component = Qt.createComponent("/opt/web2sms/accounts/EditAccountPage.qml");

        if ( component.status != Component.Ready ) {
            console.log("Error creating component:", component.errorString());
            return;
        }

        var properties = {
            "setupType":"CreateNew",
            "account":backend.createAccount(providerId)
        };

        var page = component.createObject(parent, properties);
        pageStack.push(page);
    }

    // Empty mouse area to prevent click-through!
    MouseArea {
        anchors.fill: parent
    }

    Image {
        anchors.fill: parent
        source: "image://theme/meegotouch-emptystate-background-portrait"
    }

    Label {
        id: infoLabel

        anchors {
            left: parent.left
            leftMargin: 12
            right: parent.right
            rightMargin: 12
            top: parent.top
            topMargin: 200
        }

        //% "Send SMS via internet using Web2SMS"
        text: qsTrId("qtn_web2sms_emptypage_text")
        horizontalAlignment: Text.AlignHCenter
        font.pixelSize: 48 //UIConstants.FONT_XLARGE // Xlarge is too small
        wrapMode: Text.Wrap
        color: UIConstants.COLOR_INVERTED_SECONDARY_FOREGROUND
    }

    Label {
        id: warningLabel

        anchors {
            left: parent.left
            leftMargin: 24
            right: parent.right
            rightMargin: 24
            top: infoLabel.bottom
            topMargin: 80
        }

        Image {
            id: testImage
            source: "image://theme/icon-l-web2sms"
            y: -500 // Move it away
        }

        //% "Web2SMS images in the 'Accounts' application may be missing. You have to reboot to work around this."
        text: qsTrId("qtn_web2sms_warning_images_reboot")
        visible: (testImage.status == Image.Error)
        color: "red"
        wrapMode: Text.Wrap
        horizontalAlignment: Text.AlignHCenter
    }

    Button {
        id: createButton

        Component.onCompleted: {
            // Change the color of this button
            platformStyle.inverted = true;
        }

        anchors {
            horizontalCenter: parent.horizontalCenter
            bottom: parent.bottom
            bottomMargin: 100
        }

        //% "Add account"
        text: qsTrId("qtn_web2sms_create_accounts")
        onClicked: createAccount()
    }
}
