import QtQuick 1.1
import com.nokia.meego 1.0
import "/usr/lib/qt4/imports/com/nokia/meego/UIConstants.js" as UIConstants
import Web2SMS 1.0

Rectangle {
    id: container

    property alias text: statistics.text
    property alias statistics: statistics
    property alias contacts: statistics.contacts

    property bool sendButtonEnabled: true
    signal sendClicked

    width: 300
    height: 50
    color: "white"

    MessageStatistics {
        id: statistics
    }

    Row {
        spacing: 10
        anchors {
            top: parent.top
            right: parent.right
            bottom: parent.bottom
        }

        Label {
            anchors.verticalCenter: parent.verticalCenter
            color: UIConstants.COLOR_DISABLED_FOREGROUND
            // Do we need to translate this?
            text: "Unicode"
            visible: (statistics.charset === MessageStatistics.Unicode);
        }

        Label {
            anchors.verticalCenter: parent.verticalCenter
            color: UIConstants.COLOR_DISABLED_FOREGROUND
            // TODO: Check translations
            text: qsTr("%1 (%2)").arg(statistics.charactersLeft).arg(statistics.messageCount)
        }

        ToolButton {
            Component.onCompleted: {
                platformStyle.background = "image://theme/meegotouch-button-content-overlay-navigationbar-button-inverted-background";
                platformStyle.pressedBackground = "image://theme/meegotouch-button-content-overlay-navigationbar-button-inverted-background-pressed";
                platformStyle.disabledBackground = "image://theme/meegotouch-button-content-overlay-navigationbar-button-inverted-background-disabled";

                platformStyle.textColor = "white";
                platformStyle.pressedTextColor = "white";
            }

            anchors.verticalCenter: parent.verticalCenter
            flat: true
            //% "Send"
            text: qsTrId("qtn_web2sms_messageinfopanel_send")
            enabled: container.sendButtonEnabled
            onClicked: container.sendClicked()
        }
    }
}
