import QtQuick 1.1
import com.nokia.meego 1.0

Rectangle {
    id: container

    property alias text: messageTextArea.text
    property alias realText: messageTextArea.realText

    //% "Message text"
    property string placeholderText: qsTrId("qtn_web2sms_messageinputpanel_placeholder")

    Behavior on height {
        NumberAnimation { duration: 250 }
    }

    width: 300
    height: messageTextArea.height
    color: "white"

    Image {
        id: sendIcon
        anchors {
            left: parent.left
            leftMargin: 8
            top: parent.top
            topMargin: 8
        }

        source: "image://theme/icon-m-toolbar-new-message"

        // Delegate the focus to the text field
        MouseArea {
            anchors.fill: parent
            onClicked: messageTextArea.forceActiveFocus()
        }
    }

    PlainTextArea {
        id: messageTextArea

        anchors {
            left: sendIcon.right
            leftMargin: 4
            right: parent.right
            top: parent.top
        }

        placeholderText: container.placeholderText
    }
}
