import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0
import "/usr/lib/qt4/imports/com/nokia/meego/UIConstants.js" as UIConstants
import Web2SMS 1.0

Sheet {
    id: providerSelectionPage

    property int selectedAccountId

    //% "Select"
    acceptButtonText: qsTrId("qtn_web2sms_providerselectionpage_accept")
    rejectButtonText: qsTrId("qtn_web2sms_cancel")

    property QtObject acceptButton: providerSelectionPage.buttons[1]

    Component.onCompleted: {
        var row = accountsModel.indexFromAccountId(selectedAccountId);

        console.log("Pre selecting row", row, typeof(selectedAccountId), typeof(row));

        accountsListView.currentIndex = row;
    }

    function updateSelectedAccountId(accountId) {
        providerSelectionPage.selectedAccountId = accountId;
        acceptButton.enabled = (accountsListView.currentItem != null);
    }

    content: ListView {
        id: accountsListView

        anchors.fill: parent
        anchors.margins: UIConstants.DEFAULT_MARGIN

        delegate: AccountDelegate {
            onClicked: {
                // Adjust the current index so that the
                ListView.view.currentIndex = model.index;

                // Update the account id
                updateSelectedAccountId(model.id);
            }
        }

        model: AccountsModel {
            id: accountsModel
            providerFilter: "web2sms"
        }

        Label {
            anchors.centerIn: parent
            //% "You don't have any accounts"
            text: qsTrId("qtn_web2sms_providerselectionpage_empty")
            color: UIConstants.COLOR_SECONDARY_FOREGROUND
            visible: (parent.count == 0)

            // WTF?!
            Component.onCompleted: {
                visible = parent.count == 0;
            }
        }

        ScrollDecorator {
            flickableItem: parent
        }
    }
}
