import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0
import "/usr/lib/qt4/imports/com/nokia/meego/UIConstants.js" as UIConstants
import Web2SMS 1.0

FocusScope {
    id: container

    property variant contact
    property variant contacts
    property string name
    property int count

    signal contactClicked
    signal bubbleClicked

    ////////// END OF PUBLIC API //////////

    width: 480-32
    height: UIConstants.HEADER_DEFAULT_HEIGHT_PORTRAIT

    // TODO: Do a drop shadow
    Rectangle {
        anchors.fill: parent
        color: "white"
    }

    // Selection highlighter
    BorderImage {
        anchors.fill: parent
        source: "image://theme/meegotouch-messaging-recipient-bubble-unknown-normal"
        visible: area.pressed
    }

    MouseArea {
        id: area
        anchors.fill: parent
        onClicked: {
            container.contactClicked()
        }
    }

    Label {
        anchors {
            left: parent.left
            leftMargin: UIConstants.DEFAULT_MARGIN
            right: countBubble.left
            rightMargin: UIConstants.DEFAULT_MARGIN
            verticalCenter: parent.verticalCenter
        }

        text: container.name
        elide: Text.ElideRight
        // We force to text color here, otherwise it might be invisible in night mode
        color: UIConstants.COLOR_FOREGROUND
    }

    CountBubble {
        id: countBubble

        anchors {
            right: parent.right
            rightMargin: UIConstants.DEFAULT_MARGIN
            verticalCenter: parent.verticalCenter
        }

        largeSized: true
        value: container.count
    }

    MouseArea {
        id: countBubbleArea

        anchors {
            left: countBubble.left
            leftMargin: -10
            right: parent.right
            top: parent.top
            bottom: parent.bottom
        }

        onClicked: container.bubbleClicked()
    }
}
