import QtQuick 1.0

SequentialAnimation {
    id: sizeAnimation

    /// The taget object being animated
    property QtObject target

    property int oldHeight

    onOldHeightChanged: console.log("oldHeight", oldHeight);

    PropertyAction { target: sizeAnimation; property: "oldHeight"; value: sizeAnimation.target.height }
    PropertyAction { target: sizeAnimation.target; property: "height"; value: 0}
    PropertyAnimation { duration: Math.max(0, 100*model.index) }
    NumberAnimation {
        target: sizeAnimation.target
        property: "height"
        duration: 250
        easing.type: Easing.InOutBack
        from: 0
        to: sizeAnimation.oldHeight
    }
}
