TEMPLATE = app
TARGET = web2sms-messaging-ui

android {
    DATAPATH = /assets
} else {
    DATAPATH = /opt/web2sms
}

QT += declarative network
!android: QT += dbus

CONFIG += link_pkgconfig \
          mobility

# Adjust the linker flags and add the rpath
QMAKE_LFLAGS += -Wl,-z,origin \'-Wl,-rpath,/opt/web2sms/lib\'

# Link the common web2sms library
LIBS += -L../lib -lweb2sms
INCLUDEPATH += ../lib

# Compile the package version into the binary
PACKAGEVERSION = $$system(head -n 1 ../qtc_packaging/debian_harmattan/changelog | grep -o [0-9].[0-9].[0-9])
DEFINES += "PACKAGEVERSION=\\\"$$PACKAGEVERSION\\\""

MOBILITY += contacts

android {
    INCLUDEPATH += ../../qjson/include
    LIBS += -L../../qjson/lib -lqjson
} else {
    PKGCONFIG += QJson
}

contains(MEEGO_EDITION, harmattan) {
    QMAKE_CXXFLAGS += -Wno-psabi

    DEFINES += MEEGO_EDITION_HARMATTAN
    CONFIG += notificationsystem \
              meegotouch
    PKGCONFIG += qdeclarative-boostable

    HEADERS += notificationhandler.h
    SOURCES += notificationhandler.cpp

    splashfiles.files = splash_portrait.png
    splashfiles.path = /opt/web2sms/messaging-ui
    INSTALLS += splashfiles

    desktopfile.files = web2sms.desktop
    desktopfile.path = /usr/share/applications
    INSTALLS += desktopfile
}

target.path = /opt/web2sms/bin
INSTALLS += target

qmlfiles.files = $$files(*.qml)
qmlfiles.path = $$DATAPATH/messaging-ui
INSTALLS += qmlfiles

icons.files = icon-l-web2sms.png icon-m-web2sms.png
#icons.path = /usr/share/themes/base/meegotouch/icons
icons.path = /usr/share/themes/blanco/meegotouch/icons
INSTALLS += icons

OTHER_FILES += \
    GroupPage.qml \
    ConversationPage.qml \
    main.qml \
    GroupDelegate.qml \
    BubbleItem.qml \
    BubbleItemDelegate.qml \
    ConversationView.qml \
    TopToolbar.qml \
    MessageInfoPanel.qml \
    MessageInputPanel.qml \
    NewMessagePage.qml \
    PlainTextArea.qml \
    ProviderInfoPanel.qml \
    web2sms.desktop \
    EmptyPage.qml \
    SettingsPage.qml \
    RecipientBubble.qml \
    ContactTextEdit.qml \
    SwitchWithText.qml \
    AboutPage.qml \
    splash_portrait.png \
    icon-l-web2sms.png \
    icon-m-web2sms.png \
    TileAnimation.qml \
    SizeAnimation.qml \
    SlideAnimation.qml \
    ScaleAnimation.qml \
    BubbleSettingsPage.qml \
    ProviderUpdatePage.qml \
    ProviderSelectionSheet.qml \
    ContactChooserSheet.qml \
    ProviderUpdateButton.qml

!android {
    HEADERS += appinterface.h \
               appinterface_adaptor.h

    SOURCES += appinterface.cpp \
               appinterface_adaptor.cpp
}

SOURCES += \
    main.cpp \
    settings.cpp \
    contacttexteditformatter.cpp \
    providerupdatechecker.cpp \
    providerupdateinstaller.cpp

HEADERS += \
    settings.h \
    contacttexteditformatter.h \
    providerupdatechecker.h \
    providerupdateinstaller.h










































































