#ifndef NOTIFICATIONHANDLER_H
#define NOTIFICATIONHANDLER_H

#include "settings.h"

#include <notificationsystem/notificationsink.h>

/**
   The NotificationHandler listens for new notifications and
   changes the remote action to Web2SMS instead of the default
   messaging-ui.
  */
class NotificationHandler : public NotificationSink
{
    Q_OBJECT

public:
    explicit NotificationHandler(Settings* settings, QObject *parent = 0);

    // NotificationSink overrides
public slots:
    void addNotification(const Notification &notification);
    void removeNotification(uint notificationId);

    void addGroup(uint groupId, const NotificationParameters& parameters);
    void removeGroup(uint groupId);

protected:
    Settings* settings;
};

#endif // NOTIFICATIONHANDLER_H
