import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0
import "/usr/lib/qt4/imports/com/nokia/meego/Utils.js" as Utils

// Simple wrapper around the banner class since I think it's too complicated
// for normal usage
Item {
    id: container

    property bool timerEnabled: true
    property int timerShowTime: 3000

    function showBanner(text) {
        __banner.text = text;
        __banner.show();
    }

    property InfoBanner __banner: InfoBanner {
        parent: Utils.findRootItem(container)

        timerEnabled: container.timerEnabled
        timerShowTime: container.timerShowTime

        anchors {
            left: parent.left
            leftMargin: 8
            right: parent.right
            rightMargin: 8
        }

        y: 50
    }

    Component.onDestruction: {
        container.__banner.destroy();
    }
}
