import QtQuick 1.1
import com.nokia.meego 1.0
import "/usr/lib/qt4/imports/com/nokia/meego/UIConstants.js" as UIConstants

// TODO: Delete this component when a qt-components component is available
Item {
    id: container

    property string title: "Title"
    property string subtitle: "Subtitle"
    property string imageSource: "/usr/share/themes/blanco/meegotouch/icons/icon-l-web2sms.png"
    property bool separator: true

    width: 200
    height: column.height

    Column {
        id: column
        width: container.width
        spacing: 5 // UiConstants.PortraitHeaderSpacing

        Item {
            width: parent.width
            height: Math.max(72, titleLabel.height)

            Image {
                id: imageElement
                source: container.imageSource
                width: 64
                height: 64
                visible: status == Image.Ready
            }

            Label {
                id: titleLabel

                anchors {
                    verticalCenter: parent.verticalCenter
                    right: parent.right
                    left: imageElement.visible ? imageElement.right : parent.left
                    leftMargin: imageElement.visible ? 20 : 0
                }

                text: container.title
                font.pixelSize: 32
                verticalAlignment: Text.AlignVCenter
                wrapMode: Text.Wrap
            }
        }

        Label {
            id: subtitleLabel
            text: container.subtitle
            width: parent.width
            wrapMode: Text.Wrap
            visible: text.length > 0
        }

        Separator {
            visible: separator
            width: parent.width
        }
    }
}
