TEMPLATE = lib
TARGET = qmlplugin

# Define the import path on different platforms
android:IMPORTPATH = /assets/imports
else:IMPORTPATH = /opt/web2sms/lib/imports

QT += declarative network
CONFIG += link_pkgconfig mobility plugin
MOBILITY += contacts

uri = Web2SMS

# Adjust the linker flags and add the rpath
QMAKE_LFLAGS += -Wl,-z,origin \'-Wl,-rpath,/opt/web2sms/lib\'

contains(MEEGO_EDITION, harmattan) {
    QMAKE_CXXFLAGS += -Wno-psabi

    DEFINES += MEEGO_EDITION_HARMATTAN
    PKGCONFIG += contextprovider-1.0

    # Notifications API
    ONEINCLUDE = $$QMAKE_INCDIR_QT/../one
    INCLUDEPATH += /usr/include/one $$ONEINCLUDE
}

# Link the common web2sms library
LIBS += -L../lib -lweb2sms
INCLUDEPATH += ../lib

HEADERS += plugin.h
SOURCES += plugin.cpp

OTHER_FILES = qmldir \
    AccountDelegate.qml \
    Banner.qml \
    Plugin.qml \
    Title.qml \
    Separator.qml \
    BetaWarning.qml \
    BalanceLabel.qml \
    SectionDelegate.qml \
    FastScroll.qml \
    FastScrollStyle.qml \
    FastScroll.js

qmlfiles.files = $$files(*.qml) $$files(*.js)
qmlfiles.path = $$IMPORTPATH/$$uri
INSTALLS += qmlfiles

qmldir.files = qmldir
qmldir.path = $$IMPORTPATH/$$uri
INSTALLS += qmldir

target.path = $$IMPORTPATH/$$uri
INSTALLS += target
