#!/bin/env python
# -*- coding: utf-8 -*-
#
# -----------------------------------------------------------------------------
# proken_clients.py, Copyright Bjoern Olausson
# -----------------------------------------------------------------------------
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view the license visit
# http://www.gnu.org/licenses/gpl-3.0.html
# or write to
# Free Software Foundation, Inc.
# 51 Franklin St, Fifth Floor
# Boston, MA
# 02110-1301 USA
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
#
# By Bjoern Olausson <maemo@olausson.de>
#
# https://projects.developer.nokia.com/notificationsapi/wiki/serviceapireference
#

rest_repsonse = {
    "Ok": "Ok",
    201: "Created:\n" \
        "The notification request was received but the client application " \
        "was currently not available so the notification has been stored.",
    202: "Accepted:\n" \
        "The notification request was received and accepted by the next hop " \
        "server; this does not guarantee that the notification will be " \
        "delivered to the client application.",
    204: "No content:\n" \
        "The client application is currently not able to receive " \
        "notifications.",
}

rest_error = {
    400: "Bad Request:\n" \
        "Unknown version. Only version 1.0 is currently " \
        "supported. Any other version (or no version) " \
        "returns 400 Bad Request.\n" \
        "Application ID and/or Service ID incorrect.\n" \
        "Target JID not specified " \
        "(only when sending using jid).\n" \
        "Target Application ID not specified " \
        "(only when sending using jid).\n" \
        "Target Notification ID not specified " \
        "(only when sending using nid).\n" \
        "Target Notification ID incorrect " \
        "(only when sending using nid).\n",

    401: "Unauthorized:\n"\
        "Authorization failed. " \
        "Incorrect service credentials.\n" \
        "Forbidden service. Service access to Notifications " \
        "API is forbidden.\n" \
        "TCP/TLS connection for the HTTP requests may not be persistent. " \
        "Make sure that your service uses a persistent TCP/TLS connection " \
        "for the HTTP requests.",

    408: "Request Timeout:\n" \
        "There was no indication that the message has been delivered to the " \
        "next hop server. This does not cover situations when the message " \
        "cannot be delivered to the actual mobile device, for example, " \
        "because of fade out from the wireless network coverage.",

    413: "Request Entity Too Large:\n" \
        "Payload exceeded maximum size.",

    500: "Internal Server Error\n" \
        "Server encountered an unrecoverable error.",

    503: "Service unavailable\n" \
        "Maximum number of notifications that can be sent over an hour was " \
        "exceeded.",
}
